;/------------------------------------\
;| Thorium Sprite Image (TSI) Include |
;|                                    |
;| Version 0.06 Alpha                 |
;| Last Edit: 09.29.2011              |
;|                                    |
;| PureBasic 4.51                     |
;\------------------------------------/

EnableExplicit

;---------------------------------------------------------
;Compiler Constants
;
;Here you can choose which functionalities you want to use,
;so only procedures you use will be compiled.

;Set to #True if you want to decode TSI's into PB images.
;#Tsi_Compile_PbImageDecoder  = #True

;Set to #True if you want to decode TSI's into PB sprites.
;#Tsi_Compile_PbSpriteDecoder = #False

;Set to #True if you want to encode PB images to TSI's.
;#Tsi_Compile_PbImageEncoder  = #True

;Set to #True if you want to encode PB sprites to TSI's.
;#Tsi_Compile_PbSpriteEncoder = #False

;---------------------------------------------------------
;Library Imports
;
;All needed imports of static libs and DLL's.
;If you allready have imported one of this librarys in your
;code, just comment it out here.

CompilerSelect #PB_Compiler_OS
    
  CompilerCase #PB_OS_Windows
    ImportC "zlib.lib"
      compress2(*dest, *destLen, *source, sourceLen.i, level.i)
      uncompress(*dest, *destLen, *source, sourceLen.i)
    EndImport
    XIncludeFile "B:\Projekte\PB Projekte\Thorium Game Image\TSI Include\v0.6\LZMA.pbi"

  CompilerCase #PB_OS_Linux
    ImportC #PB_Compiler_Home + "purelibraries/linux/libraries/zlib.a"
      compress2(*dest, *destLen, *source, sourceLen.i, level.i)
      uncompress(*dest, *destLen, *source, sourceLen.i)
    EndImport

  CompilerCase #PB_OS_MacOS
    ImportC "/usr/lib/libz.dylib"
      compress2(*dest, *destLen, *source, sourceLen.i, level.i)
      uncompress(*dest, *destLen, *source, sourceLen.i)
    EndImport

CompilerEndSelect

;---------------------------------------------------------
;TSI Public Constants
;
;You can use this constants as parameters for TSI procedures
;or to check error codes.
;
;Do not change anything from here!

#Tsi_Filter_None    = 0
#Tsi_Filter_Sub     = 1
#Tsi_Filter_Up      = 2
#Tsi_Filter_Average = 3

#Tsi_Transformation_None         = 0
#Tsi_Transformation_AlphaSort    = 1
#Tsi_Transformation_ChannelsSort = 2

#Tsi_Compression_None = 0
#Tsi_Compression_Zlib = 1
#Tsi_Compression_Lzma = 2
#Tsi_Compression_Thor = 3

#Tsi_Format_AsInput             =   0

#Tsi_Format_16Bit_4444          =   1
#Tsi_Format_16Bit_5551          =   2
#Tsi_Format_16Bit_565           =   3
#Tsi_Format_24Bit               =   4
#Tsi_Format_32Bit               =   5
#Tsi_Format_48Bit               =   6
#Tsi_Format_64Bit               =   7
#Tsi_Format_Index1Bit24Pal      =   8
#Tsi_Format_Index1Bit32Pal      =   9
#Tsi_Format_Index1Bit24PalAlpha =  10
#Tsi_Format_Index2Bit24Pal      =  11
#Tsi_Format_Index2Bit32Pal      =  12
#Tsi_Format_Index2Bit24PalAlpha =  13
#Tsi_Format_Index4Bit24Pal      =  14
#Tsi_Format_Index4Bit32Pal      =  15
#Tsi_Format_Index4Bit24PalAlpha =  16
#Tsi_Format_Index8Bit24Pal      =  17
#Tsi_Format_Index8Bit32Pal      =  18
#Tsi_Format_Index8Bit24PalAlpha =  19
#Tsi_Format_Grayscale1Bit       =  20
#Tsi_Format_Grayscale2Bit       =  21
#Tsi_Format_Grayscale4Bit       =  22
#Tsi_Format_Grayscale8Bit       =  23
#Tsi_Format_Grayscale16Bit      =  24
#Tsi_Format_Grayscale32Bit      =  25

#Tsi_Format_24BitIn32Bit        = 100
#Tsi_Format_48BitIn64Bit        = 101

#Tsi_ChannelOrder_AsInput = 0
#Tsi_ChannelOrder_BGRA    = 1
#Tsi_ChannelOrder_ABGR    = 2
#Tsi_ChannelOrder_RGBA    = 3
#Tsi_ChannelOrder_ARGB    = 4

#Tsi_ByteOrder_AsInput      = 0
#Tsi_ByteOrder_LittleEndian = 1
#Tsi_ByteOrder_BigEndian    = 2

#Tsi_YReversed_AsInput = 2

Enumeration 1
  #Tsi_Error_AllocMem                 ;Error on allocating memory.
  #Tsi_Error_CreateFile               ;Can't create file.
  #Tsi_Error_NoAccess                 ;Can't access file.
  #Tsi_Error_ReadFile                 ;Error on reading data from file.
  #Tsi_Error_FileToSmall              ;File size is To small, file can't be a TSI.
  #Tsi_Error_WrongSignature           ;Signature is not matching TSI signature, file isn't a TSI.
  #Tsi_Error_NotSupportedVersion      ;Not supported format version.
  #Tsi_Error_NotSupportedZlib         ;ZLib compression is not supported by the en/decoder
  #Tsi_Error_NotSupportedLzma         ;LZMA compression is not supported by the en/decoder
  #Tsi_Error_NotSupportedThor         ;Thorium compression is not supported by the en/decoder
  #Tsi_Error_DecompressZlib           ;Error on decompressing ZLib compressed TSI.
  #Tsi_Error_DecompressLzma           ;Error on decompressing LZMA compressed TSI.
  #Tsi_Error_DecompressThor           ;Error on decompressing Thorium compressed TSI.
  #Tsi_Error_CompressZlib             ;Error on compressing image data with ZLib.
  #Tsi_Error_CompressLzma             ;Error on compressing image data with LZMA.
  #Tsi_Error_CompressThor             ;Error on compressing image data with Thorium.  
  #Tsi_Error_PbCreateImage            ;Error on creating PB image.
  #Tsi_Error_PbImageAccess            ;Can't access PB image.
  #Tsi_Error_PbImageBufferAccess      ;Can't access PB image buffer.
  #Tsi_Error_PbImageWrongPixelFormat  ;PB image has wrong pixel format.
  #Tsi_Error_PbCreateSprite           ;Error on creating PB sprite.
  #Tsi_Error_PbSpriteAccess           ;Can't access PB sprite.
  #Tsi_Error_PbSpriteBufferAccess     ;Can't access PB sprite buffer.
  #Tsi_Error_PbSpriteWrongPixelFormat ;PB sprite has wrong pixel format.
EndEnumeration

;---------------------------------------------------------
;TSI Public Global Variables
;
;You can use this variables to get informations about the
;TSI procedures.
;
;Do not change anything from here!

;Holds the error code of the last occurred error.
;You can check the meaning of the code with the #Tsi_Error_
;constants.

Global Tsi_LastError.i

;---------------------------------------------------------
;TSI Private Constants
;
;Constants used internaly by the TSI procedures.
;
;Do not change anything from here!

#Tsi_PB_PixelFormat_32Bits_BGR_ReversedY = #PB_PixelFormat_32Bits_BGR | #PB_PixelFormat_ReversedY
#Tsi_PB_PixelFormat_32Bits_RGB_ReversedY = #PB_PixelFormat_32Bits_RGB | #PB_PixelFormat_ReversedY

#Tsi_Signature_Little = $6D497053726F6854 ;ThorSpIm in little endian
#Tsi_Signature_Big    = $54686F725370496D ;ThorSpIm in big endian

#Tsi_FormatVersion = 2

#Tsi_Flag_BigEndianHeader    = %00000001
#Tsi_Flag_BigEndianImage     = %00000010
#Tsi_Flag_YReversed          = %00000100
#Tsi_Flag_PixelFormatRgb     = %00001000
#Tsi_Flag_AlphaIsFirst       = %00010000
#Tsi_Flag_AlphaPremultiplied = %00100000

;---------------------------------------------------------
;TSI Private Global Variables
;
;Variables used internaly by the TSI procedures.
;
;Do not change anything from here!

Global Tsi_MmxSupported.i
Global Tsi_Sse2Supported.i
Global Tsi_Sse3Supported.i

;---------------------------------------------------------
;TSI Private Structures
;
;Structures used internaly by the TSI procedures.
;
;Do not change anything from here!

Structure Tsi_Header
  Signature.q
  FormatVersion.a
  Flags.a
  Compression.a
  Filter.a
  Transformation.a
  PixelFormat.a
  ColorCount.a
  PaletteCount.a
  TransparentColor.q
  Width.u
  Height.u
  CompressedSize.l
EndStructure

Structure Tsi_Pixel_BGR
  Blue.a
  Green.a
  Red.a
EndStructure

Structure Tsi_Pixel_BGR_16
  Blue.u
  Green.u
  Red.u
EndStructure

Structure Tsi_Pixel_BGRA
  Blue.a
  Green.a
  Red.a
  Alpha.a
EndStructure

Structure Tsi_Pixel_BGRA_16
  Blue.u
  Green.u
  Red.u
  Alpha.u
EndStructure

Structure Tsi_Pixel_Channel
  Channel.a
EndStructure

Structure Tsi_Pixel_Channel_16
  Channel.u
EndStructure

Structure Tsi_Word
  Byte1.a
  Byte2.a
EndStructure

Structure Tsi_DWord
  Byte1.a
  Byte2.a
  Byte3.a
  Byte4.a
EndStructure

Structure Tsi_QWord
  Byte1.a
  Byte2.a
  Byte3.a
  Byte4.a
  Byte5.a
  Byte6.a
  Byte7.a
  Byte8.a
EndStructure

Structure Tsi_ImageFormat
  PixelFormat.i
  ChannelOrder.i
  ByteOrder.i
  YReversed.i
  Pitch.i
EndStructure

Structure Tsi_Palettes
  EntrySize.i
  ColorCount.i
  PaletteCount.i
  *PaletteBuffer
EndStructure

Structure Tsi_UnsignedByte
  ub.a
EndStructure

Structure Tsi_UnsignedWord
  uw.u
EndStructure

;---------------------------------------------------------
;Common Procedures
;
;Do not change anything from here!

CompilerIf #PB_Compiler_Processor = #PB_Processor_x86

Procedure.i Tsi_IsCpuidSupported()

  !pushfd
  !pop eax
  !mov edx,eax
  !xor eax,$00200000
  !push eax
  !popfd
  !pushfd
  !pop eax
  !xor eax,edx
  !jne Tsi_IsCpuidSupported_Supported
  !xor eax,eax
  
  ProcedureReturn
  
  !Tsi_IsCpuidSupported_Supported:
  !mov eax,1
  
  ProcedureReturn

EndProcedure

CompilerEndIf

CompilerIf #PB_Compiler_Processor = #PB_Processor_x86 Or #PB_Compiler_Processor = #PB_Processor_x64

Procedure.i Tsi_IsMmxSupported()

  CompilerSelect #PB_Compiler_Processor

    CompilerCase #PB_Processor_x86

      !mov eax,1
      !push ebx
      !cpuid
      !pop ebx
      !test edx,$00800000
      !jne Tsi_IsMmxSupported_Supported
      !xor eax,eax
      
      ProcedureReturn
    
      !Tsi_IsMmxSupported_Supported:
      !mov eax,1
      
      ProcedureReturn
    
    CompilerCase #PB_Processor_x64

      !mov rax,1
      !push rbx
      !cpuid
      !pop rbx
      !test edx,$00800000
      !jne Tsi_IsMmxSupported_Supported
      !xor rax,rax
      
      ProcedureReturn
    
      !Tsi_IsMmxSupported_Supported:
      !mov rax,1
      
      ProcedureReturn
    
  CompilerEndSelect

EndProcedure

Procedure.i Tsi_IsSse2Supported()

  CompilerSelect #PB_Compiler_Processor

    CompilerCase #PB_Processor_x86

      !mov eax,1
      !push ebx
      !cpuid
      !pop ebx
      !test edx,$04000000
      !jne Tsi_IsSse2Supported_Supported
      !xor eax,eax
      
      ProcedureReturn
    
      !Tsi_IsSse2Supported_Supported:
      !mov eax,1
      
      ProcedureReturn
    
    CompilerCase #PB_Processor_x64

      !mov rax,1
      !push rbx
      !cpuid
      !pop rbx
      !test edx,$04000000
      !jne Tsi_IsSse2Supported_Supported
      !xor rax,rax
      
      ProcedureReturn
    
      !Tsi_IsSse2Supported_Supported:
      !mov rax,1
      
      ProcedureReturn

  CompilerEndSelect

EndProcedure

Procedure.i Tsi_IsSse3Supported()

  CompilerSelect #PB_Compiler_Processor

    CompilerCase #PB_Processor_x86

      !mov eax,1
      !push ebx
      !cpuid
      !pop ebx
      !test ecx,$00000001
      !jne Tsi_IsSse3Supported_Supported
      !xor eax,eax
      
      ProcedureReturn
    
      !Tsi_IsSse3Supported_Supported:
      !mov eax,1
      
      ProcedureReturn

    CompilerCase #PB_Processor_x64

      !mov rax,1
      !push rbx
      !cpuid
      !pop rbx
      !test ecx,$00000001
      !jne Tsi_IsSse3Supported_Supported
      !xor rax,rax
      
      ProcedureReturn
    
      !Tsi_IsSse3Supported_Supported:
      !mov rax,1
      
      ProcedureReturn

  CompilerEndSelect

EndProcedure

CompilerEndIf

Procedure Tsi_ConvertByteOrderWord(*Value.Tsi_Word)
  
  Protected.a b1, b2
  
  b1 = *Value\Byte1
  b2 = *Value\Byte2
  
  *Value\Byte1 = b2
  *Value\Byte2 = b1

EndProcedure

Procedure Tsi_ConvertByteOrderDWord(*Value.Tsi_DWord)
  
  Protected.a b1, b2, b3, b4
  
  b1 = *Value\Byte1
  b2 = *Value\Byte2
  b3 = *Value\Byte3
  b4 = *Value\Byte4
  
  *Value\Byte1 = b4
  *Value\Byte2 = b3
  *Value\Byte3 = b2
  *Value\Byte4 = b1
  
EndProcedure

Procedure Tsi_ConvertByteOrderQWord(*Value.Tsi_QWord)
  
  Protected.a b1, b2, b3, b4, b5, b6, b7, b8
  
  b1 = *Value\Byte1
  b2 = *Value\Byte2
  b3 = *Value\Byte3
  b4 = *Value\Byte4
  b5 = *Value\Byte5
  b6 = *Value\Byte6
  b7 = *Value\Byte7
  b8 = *Value\Byte8
  
  *Value\Byte1 = b8
  *Value\Byte2 = b7
  *Value\Byte3 = b6
  *Value\Byte4 = b5
  *Value\Byte5 = b4
  *Value\Byte6 = b3
  *Value\Byte7 = b2
  *Value\Byte8 = b1
  
EndProcedure

Procedure Tsi_ConvertByteOrderWordArray(*WordArray.Tsi_Word, WordArraySize.i)

  Protected.i i
  Protected.a b1, b2
  
  For i = 1 To WordArraySize
  
    b1 = *WordArray\Byte1
    b2 = *WordArray\Byte2
    
    *WordArray\Byte1 = b2
    *WordArray\Byte2 = b1
    
    *WordArray + 2
  
  Next

EndProcedure

Procedure Tsi_ConvertByteOrderDWordArray(*DWordArray.Tsi_DWord, DWordArraySize.i)

  Protected.i i
  Protected.a b1, b2, b3, b4
  
  For i = 1 To DWordArraySize
  
    b1 = *DWordArray\Byte1
    b2 = *DWordArray\Byte2
    b3 = *DWordArray\Byte3
    b4 = *DWordArray\Byte4
    
    *DWordArray\Byte1 = b4
    *DWordArray\Byte2 = b3
    *DWordArray\Byte3 = b2
    *DWordArray\Byte4 = b1
    
    *DWordArray + 4
  
  Next

EndProcedure

Procedure Tsi_ConvertByteOrderQWordArray(*QWordArray.Tsi_QWord, QWordArraySize.i)
  
  Protected.i i
  Protected.a b1, b2, b3, b4, b5, b6, b7, b8
  
  For i = 1 To QWordArraySize
    
    b1 = *Value\Byte1
    b2 = *Value\Byte2
    b3 = *Value\Byte3
    b4 = *Value\Byte4
    b5 = *Value\Byte5
    b6 = *Value\Byte6
    b7 = *Value\Byte7
    b8 = *Value\Byte8
    
    *Value\Byte1 = b8
    *Value\Byte2 = b7
    *Value\Byte3 = b6
    *Value\Byte4 = b5
    *Value\Byte5 = b4
    *Value\Byte6 = b3
    *Value\Byte7 = b2
    *Value\Byte8 = b1
    
    *QWordArray + 8
    
  Next

EndProcedure

Procedure Tsi_ConvertByteOrderWord3Channels(*Words.Tsi_Word)
  
  Protected.a b1, b2
  
    b1 = *Words\Byte1
    b2 = *Words\Byte2
    *Words\Byte1 = b2
    *Words\Byte2 = b1
    *Words + 2

    b1 = *Words\Byte1
    b2 = *Words\Byte2
    *Words\Byte1 = b2
    *Words\Byte2 = b1
    *Words + 2

    b1 = *Words\Byte1
    b2 = *Words\Byte2
    *Words\Byte1 = b2
    *Words\Byte2 = b1

EndProcedure

Procedure Tsi_ConvertByteOrderWord3ChannelsArray(*PixelArray.Tsi_Word, PixelArraySize.i)

  Protected.i i
  Protected.a b1, b2
  
  For i = 1 To PixelArraySize
  
    b1 = *PixelArray\Byte1
    b2 = *PixelArray\Byte2
    *PixelArray\Byte1 = b2
    *PixelArray\Byte2 = b1
    *PixelArray + 2

    b1 = *PixelArray\Byte1
    b2 = *PixelArray\Byte2
    *PixelArray\Byte1 = b2
    *PixelArray\Byte2 = b1
    *PixelArray + 2

    b1 = *PixelArray\Byte1
    b2 = *PixelArray\Byte2
    *PixelArray\Byte1 = b2
    *PixelArray\Byte2 = b1
    *PixelArray + 2
  
  Next

EndProcedure

Procedure.f Tsi_GetPixelSize(PixelFormat.i)

  Select PixelFormat
  
    Case #Tsi_Format_Index1Bit24Pal, #Tsi_Format_Index1Bit32Pal, #Tsi_Format_Grayscale1Bit
      ProcedureReturn 0.125
      
    Case #Tsi_Format_Index2Bit24Pal, #Tsi_Format_Index2Bit32Pal, #Tsi_Format_Grayscale2Bit
      ProcedureReturn 0.25
      
    Case #Tsi_Format_Index4Bit24Pal, #Tsi_Format_Index4Bit32Pal, #Tsi_Format_Grayscale4Bit
      ProcedureReturn 0.5
      
    Case #Tsi_Format_Index1Bit24PalAlpha
      ProcedureReturn 1.125
      
    Case #Tsi_Format_Index2Bit24PalAlpha
      ProcedureReturn 1.25
      
    Case #Tsi_Format_Index4Bit24PalAlpha
      ProcedureReturn 1.5
      
    Case #Tsi_Format_Index8Bit24Pal, #Tsi_Format_Index8Bit32Pal, #Tsi_Format_Grayscale8Bit
      ProcedureReturn 1.0
      
    Case #Tsi_Format_Index8Bit24PalAlpha, #Tsi_Format_16Bit_4444, #Tsi_Format_16Bit_5551, #Tsi_Format_16Bit_565, #Tsi_Format_Grayscale16Bit
      ProcedureReturn 2.0
      
    Case #Tsi_Format_24bit
      ProcedureReturn 3.0
      
    Case #Tsi_Format_32bit, #Tsi_Format_24BitIn32Bit, #Tsi_Format_Grayscale32Bit
      ProcedureReturn 4.0
      
    Case #Tsi_Format_48bit
      ProcedureReturn 6.0
      
    Case #Tsi_Format_64bit, #Tsi_Format_48BitIn64Bit
      ProcedureReturn 8.0
      
  EndSelect

EndProcedure

Procedure.i Tsi_GetPaletteEntrySize(PixelFormat.i)

  Select PixelFormat
    
    Case #Tsi_Format_Index1Bit24Pal, #Tsi_Format_Index1Bit24PalAlpha, #Tsi_Format_Index2Bit24Pal, #Tsi_Format_Index2Bit24PalAlpha, #Tsi_Format_Index4Bit24Pal, #Tsi_Format_Index4Bit24PalAlpha, #Tsi_Format_Index8Bit24Pal, #Tsi_Format_Index8Bit24PalAlpha
      ProcedureReturn 3
    
    Case #Tsi_Format_Index1Bit32Pal, #Tsi_Format_Index2Bit32Pal, #Tsi_Format_Index4Bit32Pal, #Tsi_Format_Index8Bit32Pal
      ProcedureReturn 4
    
    Default
      ProcedureReturn 0

  EndSelect
  
EndProcedure

;converts any image data format to any image data format
;if source isnt indexed set *SrcPalette to 0
;if destination isnt indexed set *DstPalette to 0
Procedure Tsi_ConvertImageData(Width.i, Height.i, *SrcBuffer, *SrcImageFormat.Tsi_ImageFormat, *DstBuffer, *DstImageFormat.Tsi_ImageFormat, *SrcPalette, *DstPalette)
  
  Protected X.i
  Protected Y.i
  Protected DestY.i
  Protected SrcPixelSize.i
  Protected DstPixelSize.i
  Protected *SrcPixel
  Protected *DstPixel
  Protected Pixel8.Tsi_UnsignedByte
  Protected Pixel16.Tsi_UnsignedWord
  Protected Pixel24.Tsi_Pixel_BGR
  Protected Pixel32.Long
  Protected Pixel48.Tsi_Pixel_BGR_16
  Protected Pixel64.Quad
  Protected Red.i
  Protected Green.i
  Protected Blue.i
  Protected Alpha.i
  Protected LineSize.i
  
  SrcPixelSize = Tsi_GetPixelSize(*SrcImageFormat\PixelFormat)
  DstPixelSize = Tsi_GetPixelSize(*DstImageFormat\PixelFormat)

  ;check if convertion is needed
  If *SrcImageFormat\PixelFormat = *DstImageFormat\PixelFormat And *SrcImageFormat\ChannelOrder = *DstImageFormat\ChannelOrder
    
    ;check if byte order needs to be converted
    If *SrcImageFormat\ByteOrder <> *DstImageFormat\ByteOrder
      
      Select SrcPixelSize
          
        Case 2
          Tsi_ConvertByteOrderWordArray(*SrcBuffer, Width * Height)
          
        Case 4
          Tsi_ConvertByteOrderDWordArray(*SrcBuffer, Width * Height)
          
        Case 6
          Tsi_ConvertByteOrderWord3ChannelsArray(*SrcBuffer, Width * Height)
          
        Case 8
          Tsi_ConvertByteOrderQWordArray(*SrcBuffer, Width * Height)          
          
      EndSelect
      
    EndIf
    
    ;check if pitch is the same
    If *SrcImageFormat\Pitch = *DstImageFormat\Pitch
      
      ;check if y must be reversed
      If *SrcImageFormat\YReversed = *DstImageFormat\YReversed
        
        ;the whole image can just be copied
        CopyMemory(*SrcBuffer, *DstBuffer, Width * Height * SrcPixelSize)
        
      Else
        
        ;image must be copied line by line
        LineSize = Round(Width * SrcPixelSize, #PB_Round_Up)
        Height - 1
        DestY = Height
        For Y = 0 To Height
          CopyMemory(*SrcBuffer + (*SrcImageFormat\Pitch * Y), *DstBuffer + (*DstImageFormat\Pitch * DestY), LineSize)
          DestY - 1
        Next

      EndIf
      
    Else
      
      ;image must be copied line by line
      
      ;check if y must be reversed
      If *SrcImageFormat\YReversed = *DstImageFormat\YReversed
        
        LineSize = Round(Width * SrcPixelSize, #PB_Round_Up)
        Height - 1
        For Y = 0 To Height
          CopyMemory(*SrcBuffer + (*SrcImageFormat\Pitch * Y), *DstBuffer + (*DstImageFormat\Pitch * Y), LineSize)
        Next
        
      Else
        
        LineSize = Round(Width * SrcPixelSize, #PB_Round_Up)
        Height - 1
        DestY = Height
        For Y = 0 To Height
          CopyMemory(*SrcBuffer + (*SrcImageFormat\Pitch * Y), *DstBuffer + (*DstImageFormat\Pitch * DestY), LineSize)
          DestY - 1
        Next
        
      EndIf
      
    EndIf
    
  EndIf
  
  Height - 1
  
  If *SrcImageFormat\YReversed <> *DstImageFormat\YReversed
    DestY = Height
  EndIf
  
  For Y = 0 To Height
    
    ;calculate pointer to pixel line
    *SrcPixel = *SrcBuffer + (Y * *SrcImageFormat\Pitch)
    If *SrcImageFormat\YReversed <> *DstImageFormat\YReversed
      *DstPixel = *DstBuffer + (DestY * *DstImageFormat\Pitch)
    Else
      *DstPixel = *DstBuffer + (Y * *DstImageFormat\Pitch)
    EndIf
    
    For X = 1 To Width
      
      ;get the pixel and convert byte order
      Select SrcPixelSize
          
        Case 1
          Pixel8 = PeekA(*SrcPixel)
          
        Case 2
          Pixel16 = PeekU(*SrcPixel)
          
          CompilerIf #PB_Compiler_Processor = #PB_Processor_PowerPC
            If *SrcImageFormat\ByteOrder = #Tsi_ByteOrder_LittleEndian
              Tsi_ConvertByteOrderWord(@Pixel16)
            EndIf
          CompilerElse
            If *SrcImageFormat\ByteOrder = #Tsi_ByteOrder_BigEndian
              Tsi_ConvertByteOrderWord(@Pixel16)
            EndIf
          CompilerEndIf

        Case 3
          Pixel24\Blue = PeekA(*SrcPixel)
          Pixel24\Green = PeekA(*SrcPixel + 1)
          Pixel24\Red = PeekA(*SrcPixel + 2)
          
        Case 4
          Pixel32 = PeekL(*SrcPixel)
          
          CompilerIf #PB_Compiler_Processor = #PB_Processor_PowerPC
            If *SrcImageFormat\ByteOrder = #Tsi_ByteOrder_LittleEndian
              Tsi_ConvertByteOrderDWord(@Pixel32)
            EndIf
          CompilerElse
            If *SrcImageFormat\ByteOrder = #Tsi_ByteOrder_BigEndian
              Tsi_ConvertByteOrderDWord(@Pixel32)
            EndIf
          CompilerEndIf
          
        Case 6
          Pixel48\Blue = PeekU(*SrcPixel)
          Pixel48\Green = PeekU(*SrcPixel + 2)
          Pixel48\Red = PeekU(*SrcPixel + 4)
          
          CompilerIf #PB_Compiler_Processor = #PB_Processor_PowerPC
            If *SrcImageFormat\ByteOrder = #Tsi_ByteOrder_LittleEndian
              Tsi_ConvertByteOrderWord3Channels(@Pixel48)
            EndIf
          CompilerElse
            If *SrcImageFormat\ByteOrder = #Tsi_ByteOrder_BigEndian
              Tsi_ConvertByteOrderWord3Channels(@Pixel48)
            EndIf
          CompilerEndIf

        Case 8
          Pixel64 = PeekQ(*SrcPixel)
          
          CompilerIf #PB_Compiler_Processor = #PB_Processor_PowerPC
            If *SrcImageFormat\ByteOrder = #Tsi_ByteOrder_LittleEndian
              Tsi_ConvertByteOrderQWord(@Pixel64)
            EndIf
          CompilerElse
            If *SrcImageFormat\ByteOrder = #Tsi_ByteOrder_BigEndian
              Tsi_ConvertByteOrderQWord(@Pixel64)
            EndIf
          CompilerEndIf
          
      EndSelect
      
      ;extract the components from the pixel
      Select *SrcImageFormat\PixelFormat
          
        Case #Tsi_Format_Grayscale8Bit
          Red   = Pixel8
          Green = Pixel8
          Blue  = Pixel8
          Alpha = $FF

        Case #Tsi_Format_16Bit_4444
          
          Select *SrcImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA
              Blue  = Pixel16 >> 12 & $F * 17
              Green = Pixel16 >> 8 & $F * 17
              Red   = Pixel16 >> 4 & $F * 17
              Alpha = Pixel16 & $F * 17
              
            Case #Tsi_ChannelOrder_ABGR
              Alpha = Pixel16 >> 12 & $F * 17
              Blue  = Pixel16 >> 8 & $F * 17
              Green = Pixel16 >> 4 & $F * 17
              Red   = Pixel16 & $F * 17
              
            Case #Tsi_ChannelOrder_RGBA
              Red   = Pixel16 >> 12 & $F * 17
              Green = Pixel16 >> 8 & $F * 17
              Blue  = Pixel16 >> 4 & $F * 17
              Alpha = Pixel16 & $F * 17
              
            Case #Tsi_ChannelOrder_ARGB
              Alpha = Pixel16 >> 12 & $F * 17
              Red   = Pixel16 >> 8 & $F * 17
              Green = Pixel16 >> 4 & $F * 17
              Blue  = Pixel16 & $F * 17
              
          EndSelect
          
        Case #Tsi_Format_16Bit_5551
          
          Select *SrcImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA
              Blue  = Pixel16 >> 11 & $1F * 8.2258
              Green = Pixel16 >> 6 & $1F * 8.2258
              Red   = Pixel16 >> 1 & $1F * 8.2258
              Alpha = Pixel16 & $1 * 255
              
            Case #Tsi_ChannelOrder_ABGR
              Alpha = Pixel16 >> 15 & $1 * 255
              Blue  = Pixel16 >> 10 & $1F * 8.2258
              Green = Pixel16 >> 5 & $1F * 8.2258
              Red   = Pixel16 & $1F * 8.2258
              
            Case #Tsi_ChannelOrder_RGBA
              Red   = Pixel16 >> 11 &  $1F * 8.2258
              Green = Pixel16 >> 6 & $1F * 8.2258
              Blue  = Pixel16 >> 1 & $1F * 8.2258
              Alpha = Pixel16 & $1 * 255
              
            Case #Tsi_ChannelOrder_ARGB
              Alpha = Pixel16 >> 15 & $1 * 255
              Red   = Pixel16 >> 10 & $1F * 8.2258
              Green = Pixel16 >> 5 & $1F * 8.2258
              Blue  = Pixel16 & $1F * 8.2258
              
          EndSelect
          
        Case #Tsi_Format_16Bit_565
      
          Select *SrcImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA, #Tsi_ChannelOrder_ABGR
              Blue  = Pixel16 >> 11 & $1F * 8.2258
              Green = Pixel16 >> 5 & $3F * 4.0476
              Red   = Pixel16 & $1F * 8.2258
              Alpha = $FF
              
            Case #Tsi_ChannelOrder_RGBA, #Tsi_ChannelOrder_ARGB
              Red   = Pixel16 >> 11 & $1F * 8.2258
              Green = Pixel16 >> 5 & $3F * 4.0476
              Blue  = Pixel16 & $1F * 8.2258
              Alpha = $FF
              
          EndSelect
          
        Case #Tsi_Format_Grayscale16Bit
          Red   = Pixel16 >> 8 & $FF
          Green = Red
          Blue  = Red
          Alpha = $FF
          
        Case #Tsi_Format_24Bit
          
          Select *SrcImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA, #Tsi_ChannelOrder_ABGR
              Blue  = Pixel24\Blue
              Green = Pixel24\Green
              Red   = Pixel24\Red
              Alpha = $FF
              
            Case #Tsi_ChannelOrder_RGBA, #Tsi_ChannelOrder_ARGB
              Red   = Pixel24\Blue
              Green = Pixel24\Green
              Red   = Pixel24\Red
              Alpha = $FF
              
          EndSelect
          
        Case #Tsi_Format_24BitIn32Bit
          
          Select *SrcImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA
              Blue  = Pixel32 >> 24 & $FF
              Green = Pixel32 >> 16 & $FF
              Red   = Pixel32 >> 8 & $FF
              Alpha = $FF
          
            Case #Tsi_ChannelOrder_ABGR
              Alpha = $FF
              Blue  = Pixel32 >> 16 & $FF
              Green = Pixel32 >> 8 & $FF
              Red   = Pixel32 & $FF
          
            Case #Tsi_ChannelOrder_RGBA
              Red   = Pixel32 >> 24 & $FF
              Green = Pixel32 >> 16 & $FF
              Blue  = Pixel32 >> 8 & $FF
              Alpha = $FF
          
            Case #Tsi_ChannelOrder_ARGB
              Alpha = $FF
              Red   = Pixel32 >> 16 & $FF
              Green = Pixel32 >> 8 & $FF
              Blue  = Pixel32 & $FF
              
          EndSelect
          
        Case #Tsi_Format_32Bit
          
          Select *SrcImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA
              Blue  = Pixel32 >> 24 & $FF
              Green = Pixel32 >> 16 & $FF
              Red   = Pixel32 >> 8 & $FF
              Alpha = Pixel32 & $FF
              
            Case #Tsi_ChannelOrder_ABGR
              Alpha = Pixel32 >> 24 & $FF
              Blue  = Pixel32 >> 16 & $FF
              Green = Pixel32 >> 8 & $FF
              Red   = Pixel32 & $FF
              
            Case #Tsi_ChannelOrder_RGBA
              Red   = Pixel32 >> 24 & $FF
              Green = Pixel32 >> 16 & $FF
              Blue  = Pixel32 >> 8 & $FF
              Alpha = Pixel32 & $FF
              
            Case #Tsi_ChannelOrder_ARGB
              Alpha = Pixel32 >> 24 & $FF
              Red   = Pixel32 >> 16 & $FF
              Green = Pixel32 >> 8 & $FF
              Blue  = Pixel32 & $FF
              
          EndSelect
          
        Case #Tsi_Format_Grayscale32Bit
          Red   = Pixel32 >> 16 & $FFFF
          Green = Red
          Blue  = Red
          Alpha = $FFFF
          
          If DstPixelSize < 6
            Red   = Red >> 8 & $FF
            Green = Red
            Blue  = Red
            Alpha = $FF
          EndIf

        Case #Tsi_Format_48Bit
          
          Select *SrcImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA, #Tsi_ChannelOrder_ABGR
              Blue  = Pixel48\Blue
              Green = Pixel48\Green
              Red   = Pixel48\Red
              Alpha = $FFFF
              
            Case #Tsi_ChannelOrder_RGBA, #Tsi_ChannelOrder_ARGB
              Red   = Pixel48\Blue
              Green = Pixel48\Green
              Blue  = Pixel48\Red
              Alpha = $FFFF
              
          EndSelect
          
          If DstPixelSize < 6
            Blue  = Blue >> 8 & $FF
            Green = Green >> 8 & $FF
            Red   = Red >> 8 & $FF
            Alpha = $FF
          EndIf
          
        Case #Tsi_Format_48BitIn64Bit
        
          Select *SrcImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA
              Blue  = Pixel64 >> 48 & $FFFF
              Green = Pixel64 >> 32 & $FFFF
              Red   = Pixel64 >> 16 & $FFFF
              Alpha = $FFFF
              
            Case #Tsi_ChannelOrder_ABGR
              Alpha = $FFFF
              Blue  = Pixel64 >> 32 & $FFFF
              Green = Pixel64 >> 16 & $FFFF
              Red   = Pixel64 & $FFFF
              
            Case #Tsi_ChannelOrder_RGBA
              Red   = Pixel64 >> 48 & $FFFF
              Green = Pixel64 >> 32 & $FFFF
              Blue  = Pixel64 >> 16 & $FFFF
              Alpha = $FFFF
              
            Case #Tsi_ChannelOrder_ARGB
              Alpha = $FFFF
              Red   = Pixel64 >> 32 & $FFFF
              Green = Pixel64 >> 16 & $FFFF
              Blue  = Pixel64 & $FFFF
              
          EndSelect
          
          If DstPixelSize < 6
            Blue  = Blue >> 8 & $FF
            Green = Green >> 8 & $FF
            Red   = Red >> 8 & $FF
            Alpha = $FF
          EndIf
              
        Case #Tsi_Format_64Bit
          
          Select *SrcImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA
              Blue  = Pixel64 >> 48 & $FFFF
              Green = Pixel64 >> 32 & $FFFF
              Red   = Pixel64 >> 16 & $FFFF
              Alpha = Pixel64 & $FFFF
              
            Case #Tsi_ChannelOrder_ABGR
              Alpha = Pixel64 >> 48 & $FFFF
              Blue  = Pixel64 >> 32 & $FFFF
              Green = Pixel64 >> 16 & $FFFF
              Red   = Pixel64 & $FFFF
              
            Case #Tsi_ChannelOrder_RGBA
              Red   = Pixel64 >> 48 & $FFFF
              Green = Pixel64 >> 32 & $FFFF
              Blue  = Pixel64 >> 16 & $FFFF
              Alpha = Pixel64 & $FFFF
              
            Case #Tsi_ChannelOrder_ARGB
              Alpha = Pixel64 >> 48 & $FFFF
              Red   = Pixel64 >> 32 & $FFFF
              Green = Pixel64 >> 16 & $FFFF
              Blue  = Pixel64 & $FFFF
              
          EndSelect
          
          If DstPixelSize < 6
            Blue  = Blue >> 8 & $FF
            Green = Green >> 8 & $FF
            Red   = Red >> 8 & $FF
            Alpha = Alpha >> 8 & $FF
          EndIf
  
      EndSelect
      
      ;construct pixel for destination format
      Select *DstImageFormat\PixelFormat
          
        Case #Tsi_Format_Grayscale8Bit
          Pixel8 = (Red + Green + Blue) / 3
          
        Case #Tsi_Format_Grayscale16Bit
          Pixel16 = (Red + Green + Blue) / 3
          
          If SrcPixelSize < 6
            Pixel16 = Pixel16 * 257
          EndIf
          
        Case #Tsi_Format_16Bit_4444
          
          Select *DstImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA
              Pixel16 = (Blue << 8 & $F000) | (Green << 4 & $F00) | (Red & $F0) | (Alpha >> 4 & $F)
              
            Case #Tsi_ChannelOrder_ABGR
              Pixel16 = (Alpha << 8 & $F000) | (Blue << 4 & $F00) | (Green & $F0) | (Red >> 4 & $F)
              
            Case #Tsi_ChannelOrder_RGBA
              Pixel16 = (Red << 8 & $F000) | (Green << 4 & $F00) | (Blue & $F0) | (Alpha >> 4 & $F)
              
            Case #Tsi_ChannelOrder_ARGB
              Pixel16 = (Alpha << 8 & $F000) | (Red << 4 & $F00) | (Green & $F0) | (Blue >> 4 & $F)
              
          EndSelect
          
        Case #Tsi_Format_16Bit_5551
          
          Select *DstImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA
              Pixel16 = (Blue << 8 & $F800) | (Green << 3 & $7C0) | (Red >> 2 & $3E) | (Alpha >> 7 & $1)
              
            Case #Tsi_ChannelOrder_ABGR
              Pixel16 = (Alpha << 8 & $8000) | (Blue << 7 & $7C00) | (Green << 2 & $3E0) | (Red >> 3 & $1F)
              
            Case #Tsi_ChannelOrder_RGBA
              Pixel16 = (Red << 8 & $F800) | (Green << 3 & $7C0) | (Blue >> 2 & $3E) | (Alpha >> 7 & $1)
              
            Case #Tsi_ChannelOrder_ARGB
              Pixel16 = (Alpha << 8 & $8000) | (Red << 7 & $7C00) | (Green << 2 & $3E0) | (Blue >> 3 & $1F)
              
          EndSelect
          
        Case #Tsi_Format_16Bit_565
          
          Select *DstImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA, #Tsi_ChannelOrder_ABGR
              Pixel16 = (Blue << 8 & $F800) | (Green << 3 & $7E0) | (Red >> 3 & $1F)
              
            Case #Tsi_ChannelOrder_RGBA, #Tsi_ChannelOrder_ARGB
              Pixel16 = (Red << 8 & $F800) | (Green << 3 & $7E0) | (Blue >> 3 & $1F)
              
          EndSelect
          
        Case #Tsi_Format_24Bit
          
          Select *DstImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA, #Tsi_ChannelOrder_ABGR
              Pixel24\Blue  = Blue
              Pixel24\Green = Green
              Pixel24\Red   = Red
              
            Case #Tsi_ChannelOrder_RGBA, #Tsi_ChannelOrder_ARGB
              Pixel24\Red   = Blue
              Pixel24\Green = Green
              Pixel24\Blue  = Red
              
          EndSelect
          
        Case #Tsi_Format_24BitIn32Bit
          
          Select *DstImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA
              Pixel32 = (Blue << 24) | (Green << 16) | (Red << 8) | $FF
              
            Case #Tsi_ChannelOrder_ABGR
              Pixel32 = $FF000000 | (Blue << 16) | (Green << 8) | Red
              
            Case #Tsi_ChannelOrder_RGBA
              Pixel32 = (Red << 24) | (Green << 16) | (Blue << 8) | $FF
              
            Case #Tsi_ChannelOrder_ARGB
              Pixel32 = $FF000000 | (Red << 16) | (Green << 8) | Blue
              
          EndSelect
          
        Case #Tsi_Format_32Bit
 
          Select *DstImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA
              Pixel32 = (Blue << 24) | (Green << 16) | (Red << 8) | Alpha
              
            Case #Tsi_ChannelOrder_ABGR
              Pixel32 = (Alpha << 24) | (Blue << 16) | (Green << 8) | Red
              
            Case #Tsi_ChannelOrder_RGBA
              Pixel32 = (Red << 24) | (Green << 16) | (Blue << 8) | Alpha
              
            Case #Tsi_ChannelOrder_ARGB
              Pixel32 = (Alpha << 24) | (Red << 16) | (Green << 8) | Blue
              
          EndSelect
          
        Case #Tsi_Format_Grayscale32Bit
          Pixel32 = (Red + Green + Blue) / 3
          
          If SrcPixelSize < 6
            Pixel32 = Pixel32 * 16843009
          ElseIf          
            Pixel32 = Pixel32 * 65537
          EndIf

        Case #Tsi_Format_48Bit
          
          If SrcPixelSize < 6
            Blue  = Blue * 257
            Green = Green * 257
            Red   = Red * 257
          EndIf
          
          Select *DstImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA, #Tsi_ChannelOrder_ABGR
              Pixel48\Blue  = Blue
              Pixel48\Green = Green
              Pixel48\Red   = Red
              
            Case #Tsi_ChannelOrder_RGBA, #Tsi_ChannelOrder_ARGB
              Pixel48\Red   = Blue
              Pixel48\Green = Green
              Pixel48\Blue  = Red
              
          EndSelect        
          
        Case #Tsi_Format_48BitIn64Bit
          
          If SrcPixelSize < 6
            Blue  = Blue * 257
            Green = Green * 257
            Red   = Red * 257
          EndIf          
          
          Select *DstImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA
              Pixel64 = (Blue << 48) | (Green << 32) | (Red << 16) | $FF
              
            Case #Tsi_ChannelOrder_ABGR
              Pixel64 = $FF00000000000000 | (Blue << 32) | (Green << 16) | Red
              
            Case #Tsi_ChannelOrder_RGBA
              Pixel64 = (Red << 48) | (Green << 32) | (Blue << 16) | $FF
              
            Case #Tsi_ChannelOrder_ARGB
              Pixel64 = $FF00000000000000 | (Red << 32) | (Green << 16) | Blue
              
          EndSelect
          
        Case #Tsi_Format_64Bit
          
          If SrcPixelSize < 6
            Blue  = Blue * 257
            Green = Green * 257
            Red   = Red * 257
            Alpha = Alpha * 257
          EndIf
              
          Select *DstImageFormat\ChannelOrder
              
            Case #Tsi_ChannelOrder_BGRA
              Pixel64 = (Blue << 48) | (Green << 32) | (Red << 16) | Alpha
              
            Case #Tsi_ChannelOrder_ABGR
              Pixel64 = (Alpha << 48) | (Blue << 32) | (Green << 16) | Red
              
            Case #Tsi_ChannelOrder_RGBA
              Pixel64 = (Red << 48) | (Green << 32) | (Blue << 16) | Alpha
              
            Case #Tsi_ChannelOrder_ARGB
              Pixel64 = (Alpha << 48) | (Red << 32) | (Green << 16) | Blue
              
          EndSelect
          
      EndSelect
      
      ;convert byte order
      CompilerIf #PB_Compiler_Processor = #PB_Processor_PowerPC
        If *DstImageFormat\ByteOrder = #Tsi_ByteOrder_LittleEndian
          Select DstPixelSize
            Case 2
              Tsi_ConvertByteOrderWord(@Pixel16)
            Case 4
              Tsi_ConvertByteOrderDWord(@Pixel32)
            Case 6
              Tsi_ConvertByteOrderWord3Channels(@Pixel48\Blue)
            Case 8
              Tsi_ConvertByteOrderQWord(@Pixel64)
          EndSelect
        EndIf
      CompilerElse
        If *DstImageFormat\ByteOrder = #Tsi_ByteOrder_BigEndian
          Select DstPixelSize
            Case 2
              Tsi_ConvertByteOrderWord(@Pixel16)
            Case 4
              Tsi_ConvertByteOrderDWord(@Pixel32)
            Case 6
              Tsi_ConvertByteOrderWord3Channels(@Pixel48\Blue)
            Case 8
              Tsi_ConvertByteOrderQWord(@Pixel64)
          EndSelect
        EndIf
      CompilerEndIf
      
      ;write pixel
      Select DstPixelSize
        Case 1
          PokeA(*DstPixel, Pixel8)
        Case 2
          PokeU(*DstPixel, Pixel16)
        Case 3
          PokeA(*DstPixel, Pixel24\Blue)
          PokeA(*DstPixel + 1, Pixel24\Green)
          PokeA(*DstPixel + 2, Pixel24\Red)
        Case 4
          PokeL(*DstPixel, Pixel32)
        Case 6
          PokeU(*DstPixel, Pixel48\Blue)
          PokeU(*DstPixel + 2, Pixel48\Green)
          PokeU(*DstPixel + 4, Pixel48\Red)
        Case 8
          PokeQ(*DstPixel, Pixel64)
      EndSelect
      
      ;get pointer to next pixel
      *SrcPixel + SrcPixelSize
      *DstPixel + DstPixelSize

    Next
    
    If *SrcImageFormat\YReversed <> *DstImageFormat\YReversed
      DestY - 1
    EndIf
    
  Next

EndProcedure

;initialisizes the TSI encoder/decoder
;call one time befor you use any of the procedures of the TSI encoder/decoder
Procedure Tsi_Init()

  CompilerSelect #PB_Compiler_Processor

    CompilerCase #PB_Processor_x86

      If Tsi_IsCpuidSupported() = #False
        Tsi_MmxSupported  = #False
        Tsi_Sse2Supported = #False
        Tsi_Sse3Supported = #False
      Else
        Tsi_MmxSupported  = Tsi_IsMmxSupported()
        Tsi_Sse2Supported = Tsi_IsSse2Supported()
        Tsi_Sse3Supported = Tsi_IsSse3Supported()
      EndIf

    CompilerCase #PB_Processor_x64
    
      Tsi_MmxSupported  = Tsi_IsMmxSupported()
      Tsi_Sse2Supported = Tsi_IsSse2Supported()
      Tsi_Sse3Supported = Tsi_IsSse3Supported()

    CompilerDefault
    
      Tsi_MmxSupported  = #False
      Tsi_Sse2Supported = #False
      Tsi_Sse3Supported = #False
  
  CompilerEndSelect

EndProcedure

;---------------------------------------------------------
;TSI Decoder, Shared Procedures
;
;Do not change anything from here!

CompilerIf #Tsi_Compile_PbImageDecoder = #True Or #Tsi_Compile_PbSpriteDecoder = #True

;Loads a TSI from a file to memory and returns the pointer to it.
;File size will be returned in *TsiSize.
;This procedure does not decode the TSI, it just loads the file unmodified to memory.
;Returns 0 if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_LoadTsiFile(FileName.s, *TsiSize.Integer)

  Protected.i File, ReadBytes
  Protected *FileBuffer
  
  File = ReadFile(#PB_Any, FileName)
  If File = 0
    Tsi_LastError = #Tsi_Error_NoAccess
    Debug "Tsi_LoadTsiFile: Can't access file: " + FileName
    ProcedureReturn 0
  EndIf
  
  *TsiSize\i = Lof(File)
  If *TsiSize\i < SizeOf(Tsi_Header)
    Tsi_LastError = #Tsi_Error_FileToSmall
    CloseFile(File)
    Debug "Tsi_LoadTsiFile: File size to small, file can't be a TSI."
    ProcedureReturn 0
  EndIf
  
  *FileBuffer = AllocateMemory(*TsiSize\i)
  If *FileBuffer = 0
    Tsi_LastError = #Tsi_Error_AllocMem
    Debug "Tsi_LoadTsiFile: Error on allocating memory."
    ProcedureReturn 0
  EndIf

  ReadBytes = ReadData(File, *FileBuffer, *TsiSize\i)
  CloseFile(File)
  
  If ReadBytes <> *TsiSize\i
    FreeMemory(*FileBuffer)
    Tsi_LastError = #Tsi_Error_ReadFile
    Debug "Tsi_LoadTsiFile: Error on reading data from file."
    ProcedureReturn 0
  EndIf

  ProcedureReturn *FileBuffer

EndProcedure

;Undos the sort alpha transformation on 32 bit image data.
Procedure Tsi_UnSortAlpha32(*ImageData, Size.i)

  Protected.i ByteSize
  Protected *Buffer

  ByteSize = Size * 4
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)

  CompilerSelect #PB_Compiler_Processor
  
    CompilerCase #PB_Processor_x86

      !push edi
      !push esi
      !push ebx

      !mov ecx,[p.v_Size+12]
      !mov edi,[p.p_ImageData+12]
      !mov esi,[p.p_Buffer+12]
      !mov ebx,esi
      !add ebx,ecx
      
      !align 4
      !Tsi_UnSortAlpha32_LoopStart:
        
        !mov al,[ebx]
        !mov [edi],al
        !inc ebx
        !inc edi
        
        !mov al,[ebx]
        !mov [edi],al
        !inc ebx
        !inc edi

        !mov al,[ebx]
        !mov [edi],al
        !inc ebx
        !inc edi

        !mov al,[esi]
        !mov [edi],al
        !inc esi
        !inc edi
        
      !dec ecx
      !jne Tsi_UnSortAlpha32_LoopStart

      !pop ebx
      !pop esi
      !pop edi

    CompilerCase #PB_Processor_x64
    
      !push rdi
      !push rsi
      !push rbx

      !mov rcx,[p.v_Size+24]
      !mov rdi,[p.p_ImageData+24]
      !mov rsi,[p.p_Buffer+24]
      !mov rbx,rsi
      !add rbx,rcx
      
      !align 8
      !Tsi_UnSortAlpha32_LoopStart:
        
        !mov al,[rbx]
        !mov [rdi],al
        !inc rbx
        !inc rdi
        
        !mov al,[rbx]
        !mov [rdi],al
        !inc rbx
        !inc rdi

        !mov al,[rbx]
        !mov [rdi],al
        !inc rbx
        !inc rdi

        !mov al,[rsi]
        !mov [rdi],al
        !inc rsi
        !inc rdi
        
      !dec rcx
      !jne Tsi_UnSortAlpha32_LoopStart

      !pop rbx
      !pop rsi
      !pop rdi

    CompilerDefault
    
      Protected.i i
      Protected *PixelPos.Tsi_Pixel_BGRA
      Protected *AlphaPos.Tsi_Pixel_Channel
      Protected *ColorPos.Tsi_Pixel_BGR
      
      *PixelPos = *ImageData
      *AlphaPos = *Buffer
      *ColorPos = *Buffer + Size
       
      For i = 1 To Size
        
        *PixelPos\Alpha = *AlphaPos\Channel
        *AlphaPos + 1
        
        *PixelPos\Blue  = *ColorPos\Blue 
        *PixelPos\Green = *ColorPos\Green
        *PixelPos\Red   = *ColorPos\Red
        *ColorPos + 3
        
        *PixelPos + 4
    
      Next

  CompilerEndSelect

  FreeMemory(*Buffer)

EndProcedure

;Undos the sort alpha transformation on 64 bit image data.
Procedure Tsi_UnSortAlpha64(*ImageData, Size.i)

  Protected.i ByteSize
  Protected *Buffer

  ByteSize = Size * 8
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)

  CompilerSelect #PB_Compiler_Processor
  
    CompilerCase #PB_Processor_x86
      
      !push edi
      !push esi
      !push ebx

      !mov ecx,[p.v_Size+12]
      !mov edi,[p.p_ImageData+12]
      !mov esi,[p.p_Buffer+12]
      !mov ebx,esi
      !add ebx,ecx
      !add ebx,ecx
      
      !align 4
      !Tsi_UnSortAlpha64_LoopStart:
        
        !mov ax,[ebx]
        !mov [edi],ax
        !add ebx,2
        !add edi,2
        
        !mov ax,[ebx]
        !mov [edi],ax
        !add ebx,2
        !add edi,2
        
        !mov ax,[ebx]
        !mov [edi],ax
        !add ebx,2
        !add edi,2

        !mov ax,[esi]
        !mov [edi],ax
        !add esi,2
        !add edi,2
        
      !dec ecx
      !jne Tsi_UnSortAlpha64_LoopStart

      !pop ebx
      !pop esi
      !pop edi

    CompilerCase #PB_Processor_x64
    
      !push rdi
      !push rsi
      !push rbx

      !mov rcx,[p.v_Size+24]
      !mov rdi,[p.p_ImageData+24]
      !mov rsi,[p.p_Buffer+24]
      !mov rbx,rsi
      !add rbx,rcx
      !add rbx,rcx
      
      !align 8
      !Tsi_UnSortAlpha64_LoopStart:
        
        !mov ax,[rbx]
        !mov [rdi],ax
        !add rbx,2
        !add rdi,2
        
        !mov ax,[rbx]
        !mov [rdi],ax
        !add rbx,2
        !add rdi,2
        
        !mov ax,[rbx]
        !mov [rdi],ax
        !add rbx,2
        !add rdi,2

        !mov ax,[rsi]
        !mov [rdi],ax
        !add rsi,2
        !add rdi,2
        
      !dec rcx
      !jne Tsi_UnSortAlpha64_LoopStart

      !pop rbx
      !pop rsi
      !pop rdi

    CompilerDefault
    
      Protected.i i
      Protected *PixelPos.Tsi_Pixel_BGRA_16
      Protected *AlphaPos.Tsi_Pixel_Channel_16
      Protected *ColorPos.Tsi_Pixel_BGR_16
      
      *PixelPos = *ImageData
      *AlphaPos = *Buffer
      *ColorPos = *Buffer + (Size * 2)
      
      For i = 1 To Size
        
        *PixelPos\Alpha = *AlphaPos\Channel
        *AlphaPos + 2
        
        *PixelPos\Blue  = *ColorPos\Blue 
        *PixelPos\Green = *ColorPos\Green
        *PixelPos\Red   = *ColorPos\Red
        *ColorPos + 6
        
        *PixelPos + 8
    
      Next

  CompilerEndSelect

  FreeMemory(*Buffer)

EndProcedure

;Undos the sort channels transformation on 24 bit image data.
Procedure Tsi_UnSortChannels24(*ImageData, Size.i)

  Protected.i ByteSize
  Protected *Buffer

  ByteSize = Size * 3
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)

  CompilerSelect #PB_Compiler_Processor
  
    CompilerCase #PB_Processor_x86
      
      !push edi
      !push ebx
      !push ebp
      
      !mov ecx,[p.v_Size+12]
      !mov edi,[p.p_ImageData+12]
      !mov edx,[p.p_Buffer+12]
      !mov ebx,edx
      !add ebx,ecx
      !mov ebp,ebx
      !add ebp,ecx

      !align 4
      !Tsi_UnSortChannels24_LoopStart:

        !mov al,[edx]
        !mov [edi],al
        !inc edx
        !inc edi
        
        !mov al,[ebx]
        !mov [edi],al
        !inc ebx
        !inc edi
        
        !mov al,[ebp]
        !mov [edi],al
        !inc ebp
        !inc edi
      
      !dec ecx
      !jne Tsi_UnSortChannels24_LoopStart
      
      !pop ebp
      !pop ebx
      !pop edi

    CompilerCase #PB_Processor_x64

      !push rdi
      !push rbx
      !push rbp
      
      !mov rcx,[p.v_Size+24]
      !mov rdi,[p.p_ImageData+24]
      !mov rdx,[p.p_Buffer+24]
      !mov rbx,rdx
      !add rbx,rcx
      !mov rbp,rbx
      !add rbp,rcx

      !align 8
      !Tsi_UnSortChannels24_LoopStart:

        !mov al,[rdx]
        !mov [rdi],al
        !inc rdx
        !inc rdi
        
        !mov al,[rbx]
        !mov [rdi],al
        !inc rbx
        !inc rdi
        
        !mov al,[rbp]
        !mov [rdi],al
        !inc rbp
        !inc rdi
      
      !dec rcx
      !jne Tsi_UnSortChannels24_LoopStart
      
      !pop rbp
      !pop rbx
      !pop rdi

    CompilerDefault
      
      Protected.i i
      Protected *PixelPos.Tsi_Pixel_BGR
      Protected *BluePos.Tsi_Pixel_Channel
      Protected *GreenPos.Tsi_Pixel_Channel
      Protected *RedPos.Tsi_Pixel_Channel  

      *PixelPos = *ImageData
      
      *BluePos  = *Buffer
      *GreenPos = *BluePos + Size
      *RedPos   = *GreenPos + Size
      
      For i = 1 To Size
        
        *PixelPos\Blue  = *BluePos\Channel
        *BluePos + 1
        
        *PixelPos\Green = *GreenPos\Channel
        *GreenPos + 1
    
        *PixelPos\Red   = *RedPos\Channel
        *RedPos + 1
        
        *PixelPos + 3
    
      Next
  
  CompilerEndSelect
  
  FreeMemory(*Buffer)

EndProcedure

;Undos the sort channels transformation on 32 bit image data.
Procedure Tsi_UnSortChannels32(*ImageData, Size.i)

  Protected.i ByteSize
  Protected *Buffer

  ByteSize = Size * 4
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)

  CompilerSelect #PB_Compiler_Processor
  
    CompilerCase #PB_Processor_x86
      
      !push edi
      !push ebx
      !push ebp
      !push esi
      
      !mov ecx,[p.v_Size+16]
      !mov edi,[p.p_ImageData+16]
      !mov edx,[p.p_Buffer+16]
      !mov ebx,edx
      !add ebx,ecx
      !mov ebp,ebx
      !add ebp,ecx
      !mov esi,ebp
      !add esi,ecx

      !align 4
      !Tsi_UnSortChannels32_LoopStart:

        !mov al,[edx]
        !mov [edi],al
        !inc edx
        !inc edi
        
        !mov al,[ebx]
        !mov [edi],al
        !inc ebx
        !inc edi
        
        !mov al,[ebp]
        !mov [edi],al
        !inc ebp
        !inc edi
        
        !mov al,[esi]
        !mov [edi],al
        !inc esi
        !inc edi
      
      !dec ecx
      !jne Tsi_UnSortChannels32_LoopStart
      
      !pop esi
      !pop ebp
      !pop ebx
      !pop edi

    CompilerCase #PB_Processor_x64

      !push rdi
      !push rbx
      !push rbp
      !push rsi
      
      !mov rcx,[p.v_Size+32]
      !mov rdi,[p.p_ImageData+32]
      !mov rdx,[p.p_Buffer+32]
      !mov rbx,rdx
      !add rbx,rcx
      !mov rbp,rbx
      !add rbp,rcx
      !mov rsi,rbp
      !add rsi,rcx

      !align 8
      !Tsi_UnSortChannels32_LoopStart:

        !mov al,[rdx]
        !mov [rdi],al
        !inc rdx
        !inc rdi
        
        !mov al,[rbx]
        !mov [rdi],al
        !inc rbx
        !inc rdi
        
        !mov al,[rbp]
        !mov [rdi],al
        !inc rbp
        !inc rdi
        
        !mov al,[rsi]
        !mov [rdi],al
        !inc rsi
        !inc rdi
      
      !dec rcx
      !jne Tsi_UnSortChannels32_LoopStart
      
      !pop rsi
      !pop rbp
      !pop rbx
      !pop rdi

    CompilerDefault
      
      Protected.i i
      Protected *PixelPos.Tsi_Pixel_BGRA
      Protected *BluePos.Tsi_Pixel_Channel
      Protected *GreenPos.Tsi_Pixel_Channel
      Protected *RedPos.Tsi_Pixel_Channel  
      Protected *AlphaPos.Tsi_Pixel_Channel

      *PixelPos = *ImageData
      
      *BluePos  = *Buffer
      *GreenPos = *BluePos + Size
      *RedPos   = *GreenPos + Size
      *AlphaPos = *RedPos + Size
      
      For i = 1 To Size
        
        *PixelPos\Blue  = *BluePos\Channel
        *BluePos + 1
        
        *PixelPos\Green = *GreenPos\Channel
        *GreenPos + 1
    
        *PixelPos\Red   = *RedPos\Channel
        *RedPos + 1
    
        *PixelPos\Alpha = *AlphaPos\Channel
        *AlphaPos + 1
        
        *PixelPos + 4
    
      Next
  
  CompilerEndSelect
  
  FreeMemory(*Buffer)

EndProcedure

;Undos the sort channels transformation on 48 bit image data.
Procedure Tsi_UnSortChannels48(*ImageData, Size.i)

  Protected.i ByteSize
  Protected *Buffer

  ByteSize = Size * 6
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)

  CompilerSelect #PB_Compiler_Processor
  
    CompilerCase #PB_Processor_x86
      
      !push edi
      !push ebx
      !push ebp
      
      !mov ecx,[p.v_Size+12]
      !mov edi,[p.p_ImageData+12]
      !mov edx,[p.p_Buffer+12]
      !mov ebx,edx
      !add ebx,ecx
      !add ebx,ecx
      !mov ebp,ebx
      !add ebp,ecx
      !add ebp,ecx

      !align 4
      !Tsi_UnSortChannels48_LoopStart:

        !mov ax,[edx]
        !mov [edi],ax
        !add edx,2
        !add edi,2
        
        !mov ax,[ebx]
        !mov [edi],ax
        !add ebx,2
        !add edi,2
        
        !mov ax,[ebp]
        !mov [edi],ax
        !add ebp,2
        !add edi,2
      
      !dec ecx
      !jne Tsi_UnSortChannels48_LoopStart
      
      !pop ebp
      !pop ebx
      !pop edi

    CompilerCase #PB_Processor_x64

      !push rdi
      !push rbx
      !push rbp
      
      !mov rcx,[p.v_Size+24]
      !mov rdi,[p.p_ImageData+24]
      !mov rdx,[p.p_Buffer+24]
      !mov rbx,rdx
      !add rbx,rcx
      !add rbx,rcx
      !mov rbp,rbx
      !add rbp,rcx
      !add rbp,rcx

      !align 8
      !Tsi_UnSortChannels48_LoopStart:

        !mov al,[rdx]
        !mov [rdi],aa
        !add rdx,2
        !add rdi,2
        
        !mov ax,[rbx]
        !mov [rdi],ax
        !add rbx,2
        !add rdi,2
        
        !mov ax,[rbp]
        !mov [rdi],ax
        !add rbp,2
        !add rdi,2
      
      !dec rcx
      !jne Tsi_UnSortChannels48_LoopStart
      
      !pop rbp
      !pop rbx
      !pop rdi

    CompilerDefault
      
      Protected.i i
      Protected *PixelPos.Tsi_Pixel_BGR_16
      Protected *BluePos.Tsi_Pixel_Channel_16
      Protected *GreenPos.Tsi_Pixel_Channel_16
      Protected *RedPos.Tsi_Pixel_Channel_16

      *PixelPos = *ImageData
      
      *BluePos  = *Buffer
      *GreenPos = *BluePos + (Size * 2)
      *RedPos   = *GreenPos + (Size * 2)
      
      For i = 1 To Size
        
        *PixelPos\Blue  = *BluePos\Channel
        *BluePos + 2
        
        *PixelPos\Green = *GreenPos\Channel
        *GreenPos + 2
    
        *PixelPos\Red   = *RedPos\Channel
        *RedPos + 2
        
        *PixelPos + 6
    
      Next
  
  CompilerEndSelect
  
  FreeMemory(*Buffer)

EndProcedure

;Undos the sort channels transformation on 64 bit image data.
Procedure Tsi_UnSortChannels64(*ImageData, Size.i)

  Protected.i ByteSize
  Protected *Buffer

  ByteSize = Size * 8
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)

  CompilerSelect #PB_Compiler_Processor
  
    CompilerCase #PB_Processor_x86
      
      !push edi
      !push ebx
      !push ebp
      !push esi
      
      !mov ecx,[p.v_Size+16]
      !mov edi,[p.p_ImageData+16]
      !mov edx,[p.p_Buffer+16]
      !mov ebx,edx
      !add ebx,ecx
      !add ebx,ecx
      !mov ebp,ebx
      !add ebp,ecx
      !add ebp,ecx
      !mov esi,ebp
      !add esi,ecx
      !add esi,ecx

      !align 4
      !Tsi_UnSortChannels64_LoopStart:

        !mov ax,[edx]
        !mov [edi],ax
        !add edx,2
        !add edi,2
        
        !mov ax,[ebx]
        !mov [edi],ax
        !add ebx,2
        !add edi,2
        
        !mov ax,[ebp]
        !mov [edi],ax
        !add ebp,2
        !add edi,2
        
        !mov ax,[esi]
        !mov [edi],ax
        !add esi,2
        !add edi,2
      
      !dec ecx
      !jne Tsi_UnSortChannels64_LoopStart
      
      !pop esi
      !pop ebp
      !pop ebx
      !pop edi

    CompilerCase #PB_Processor_x64

      !push rdi
      !push rbx
      !push rbp
      !push rsi
      
      !mov rcx,[p.v_Size+32]
      !mov rdi,[p.p_ImageData+32]
      !mov rdx,[p.p_Buffer+32]
      !mov rbx,rdx
      !add rbx,rcx
      !add rbx,rcx
      !mov rbp,rbx
      !add rbp,rcx
      !add rbp,rcx
      !mov rsi,rbp
      !add rsi,rcx
      !add rsi,rcx

      !align 8
      !Tsi_UnSortChannels64_LoopStart:

        !mov ax,[rdx]
        !mov [rdi],ax
        !add rdx,2
        !add rdi,2
        
        !mov ax,[rbx]
        !mov [rdi],ax
        !add rbx,2
        !add rdi,2
        
        !mov ax,[rbp]
        !mov [rdi],ax
        !add rbp,2
        !add rdi,2
        
        !mov ax,[rsi]
        !mov [rdi],ax
        !add rsi,2
        !add rdi,2
      
      !dec rcx
      !jne Tsi_UnSortChannels64_LoopStart
      
      !pop rsi
      !pop rbp
      !pop rbx
      !pop rdi

    CompilerDefault
      
      Protected.i i
      Protected *PixelPos.Tsi_Pixel_BGRA_16
      Protected *BluePos.Tsi_Pixel_Channel_16
      Protected *GreenPos.Tsi_Pixel_Channel_16
      Protected *RedPos.Tsi_Pixel_Channel_16
      Protected *AlphaPos.Tsi_Pixel_Channel_16

      *PixelPos = *ImageData
      
      *BluePos  = *Buffer
      *GreenPos = *BluePos + (Size * 2)
      *RedPos   = *GreenPos + (Size * 2)
      *AlphaPos = *RedPos + (Size * 2)
      
      For i = 1 To Size
        
        *PixelPos\Blue  = *BluePos\Channel
        *BluePos + 2
        
        *PixelPos\Green = *GreenPos\Channel
        *GreenPos + 2
    
        *PixelPos\Red   = *RedPos\Channel
        *RedPos + 2
    
        *PixelPos\Alpha = *AlphaPos\Channel
        *AlphaPos + 2
        
        *PixelPos + 8
    
      Next
  
  CompilerEndSelect
  
  FreeMemory(*Buffer)

EndProcedure

;Undos the sub filter.
Procedure Tsi_UnFilterSub(*ImageData, Width.i, Height.i, PixelSize.i)

  CompilerSelect #PB_Compiler_Processor
  
    CompilerCase #PB_Processor_x86

      !push edx
      !push ebx
      !push esi
      !push edi
      !push ebp
      
      !mov ebp,[p.v_PixelSize+20]
      
      !mov esi,[p.p_ImageData+20]
      !mov edi,esi
      !add edi,ebp
      
      !mov eax,[p.v_Width+20]
      !dec eax
      !mul ebp
      !mov ebx,eax
      
      !mov edx,[p.v_Height+20]
      
      !align 4
      !Tsi_UnFilterSub_Y_LoopStart:
      
        !mov ecx,ebx
        
        !align 4
        !Tsi_UnFilterSub_X_LoopStart:
      
          !mov al,[edi]
          !add al,[esi]
          !mov [edi],al
          !inc edi
          !inc esi

        !dec ecx
        !jne Tsi_UnFilterSub_X_LoopStart

        !add edi,ebp
        !add esi,ebp
        
      !dec edx
      !jne Tsi_UnFilterSub_Y_LoopStart

      !pop ebp
      !pop edi
      !pop esi
      !pop ebx
      !pop edx
      
    CompilerCase #PB_Processor_x64

      !push rdx
      !push rsi
      !push rdi

      !mov r11,[p.v_PixelSize+24]

      !mov rsi,[p.p_ImageData+24]
      !mov rdi,rsi
      !add rdi,r11
      
      !mov rax,[p.v_Width+24]
      !dec rax
      !mul r11
      !mov r10,rax

      !mov rdx,[p.v_Height+24]
      
      !align 8
      !Tsi_UnFilterSub_Y_LoopStart:
      
        !mov rcx,r10
        
        !align 8
        !Tsi_UnFilterSub_X_LoopStart:
      
          !mov al,[rdi]
          !add al,[rsi]
          !mov [rdi],al
          !inc rdi
          !inc rsi

        !dec rcx
        !jne Tsi_UnFilterSub_X_LoopStart

        !add rdi,r11
        !add rsi,r11
        
      !dec rdx
      !jne Tsi_UnFilterSub_Y_LoopStart
      
      !pop rdi
      !pop rsi
      !pop rdx

    CompilerDefault

      Protected.i X, Y
      Protected *ActualChannel.Tsi_Pixel_Channel
      Protected *PriorChannel.Tsi_Pixel_Channel
    
      *PriorChannel  = *ImageData
      *ActualChannel = *ImageData + PixelSize
    
      Width - 1
      Width = Width * PixelSize
      
      For Y = 1 To Height
      
        For X = 1 To Width
        
          *ActualChannel\Channel = *ActualChannel\Channel + *PriorChannel\Channel
          *ActualChannel + 1
          *PriorChannel + 1
        
        Next
        
        *PriorChannel + PixelSize
        *ActualChannel + PixelSize
        
      Next

  CompilerEndSelect
    
EndProcedure

;Undos the up filter.
Procedure Tsi_UnFilterUp(*ImageData, Width.i, Height.i, PixelSize.i)

  CompilerSelect #PB_Compiler_Processor
  
    CompilerCase #PB_Processor_x86

      If Tsi_Sse2Supported = #True

        ;save registers
        !push esi
        !push edi
        !push ebx

        ;calculate the pointers
        !mov edi,[p.p_ImageData+12]
        !mov esi,edi
        !mov eax,[p.v_Width+12]
        !mul dword[p.v_PixelSize+12]
        !mov edx,eax
        !add edi,edx

        ;calculate the counters
        !mov eax,[p.v_Height+12]
        !dec eax
        !mul dword[p.v_Width+12]
        !mul dword[p.v_PixelSize+12]
        !mov ecx,eax
        !shr ecx,7
        !and eax,127
        !mov ebx,eax
        
        ;process a part of the data to cut the length to a multiple of 128
        !test ebx,ebx
        !je Tsi_UnFilterUp_Sse2CutLengthEnd
        
        !align 4
        !Tsi_UnFilterUp_Sse2CutLengthStart:

          !mov al,[edi]
          !add al,[esi]
          !mov [edi],al
          
          !inc esi
          !inc edi
      
        !dec ebx
        !jne Tsi_UnFilterUp_Sse2CutLengthStart

        !align 4
        !Tsi_UnFilterUp_Sse2CutLengthEnd:
        
        ;process the rest of the data
        !test ecx,ecx
        !je Tsi_UnFilterUp_Sse2LoopEnd
        
        !align 4
        !Tsi_UnFilterUp_Sse2LoopStart:

          !movdqu xmm0,[esi]
          !movdqu xmm1,[esi+16]
          !movdqu xmm2,[esi+32]
          !movdqu xmm3,[esi+48]
          !movdqu xmm4,[esi+64]
          !movdqu xmm5,[esi+80]
          !movdqu xmm6,[esi+96]
          !movdqu xmm7,[esi+112]
          
          !paddb xmm0,[edi]
          !paddb xmm1,[edi+16]
          !paddb xmm2,[edi+32]
          !paddb xmm3,[edi+48]
          !paddb xmm4,[edi+64]
          !paddb xmm5,[edi+80]
          !paddb xmm6,[edi+96]
          !paddb xmm7,[edi+112]

          !movdqu [edi],xmm0
          !movdqu [edi+16],xmm1
          !movdqu [edi+32],xmm2
          !movdqu [edi+48],xmm3
          !movdqu [edi+64],xmm4
          !movdqu [edi+80],xmm5
          !movdqu [edi+96],xmm6
          !movdqu [edi+112],xmm7

          !add esi,128
          !add edi,128
        
        !dec ecx
        !jne Tsi_UnFilterUp_Sse2LoopStart
        
        !align 4
        !Tsi_UnFilterUp_Sse2LoopEnd:

        ;restore the registers
        !pop ebx
        !pop edi
        !pop esi

        ;end SSE2 state
        !emms

      ElseIf Tsi_MmxSupported = #True

        ;save registers
        !push esi
        !push edi
        !push ebx

        ;calculate the pointers
        !mov edi,[p.p_ImageData+12]
        !mov esi,edi
        !mov eax,[p.v_Width+12]
        !mul dword[p.v_PixelSize+12]
        !mov edx,eax
        !add edi,edx

        ;calculate the counters
        !mov eax,[p.v_Height+12]
        !dec eax
        !mul dword[p.v_Width+12]
        !mul dword[p.v_PixelSize+12]
        !mov ecx,eax
        !shr ecx,6
        !and eax,63
        !mov ebx,eax

        ;process a part of the data to cut the length to a multiple of 64
        !test ebx,ebx
        !je Tsi_UnFilterUp_MmxCutLengthEnd
        
        !align 4
        !Tsi_UnFilterUp_MmxCutLengthStart:
      
          !mov al,[edi]
          !add al,[esi]
          !mov [edi],al
          
          !inc esi
          !inc edi
      
        !dec ebx
        !jne Tsi_UnFilterUp_MmxCutLengthStart

        !align 4
        !Tsi_UnFilterUp_MmxCutLengthEnd:

        ;process the rest of the data
        !test ecx,ecx
        !je Tsi_UnFilterUp_MmxLoopEnd

        !align 4
        !Tsi_UnFilterUp_MmxLoopStart:

          !movq mm0,[esi]
          !movq mm1,[esi+8]
          !movq mm2,[esi+16]
          !movq mm3,[esi+24]
          !movq mm4,[esi+32]
          !movq mm5,[esi+40]
          !movq mm6,[esi+48]
          !movq mm7,[esi+56]

          !paddb mm0,[edi]
          !paddb mm1,[edi+8]
          !paddb mm2,[edi+16]
          !paddb mm3,[edi+24]
          !paddb mm4,[edi+32]
          !paddb mm5,[edi+40]
          !paddb mm6,[edi+48]
          !paddb mm7,[edi+56]

          !movq [edi],mm0
          !movq [edi+8],mm1
          !movq [edi+16],mm2
          !movq [edi+24],mm3
          !movq [edi+32],mm4
          !movq [edi+40],mm5
          !movq [edi+48],mm6
          !movq [edi+56],mm7
          
          !add esi,64
          !add edi,64

        !dec ecx
        !jne Tsi_UnFilterUp_MmxLoopStart

        !align 4
        !Tsi_UnFilterUp_MmxLoopEnd:

        ;restore the registers
        !pop ebx
        !pop edi
        !pop esi

        ;end MMX state
        !emms
      
      Else
      
        !push esi
        !push edi
  
        !mov eax,[p.v_Height+8]
        !dec eax
        !mul dword[p.v_Width+8]
        !mul dword[p.v_PixelSize+8]
        !mov ecx,eax
        
        !mov edi,[p.p_ImageData+8]
        !mov esi,edi
        
        !mov eax,[p.v_Width+8]
        !mul dword[p.v_PixelSize+8]
        !mov edx,eax
        !add edi,edx
        
        !align 4
        !Tsi_UnFilterUp_LoopStart:
        
          !mov al,[edi]
          !add al,[esi]
          !mov [edi],al
          
          !inc esi
          !inc edi
          
        !dec ecx
        !jne Tsi_UnFilterUp_LoopStart
      
        !pop edi
        !pop esi
      
      EndIf
    
    CompilerCase #PB_Processor_x64

      If Tsi_Sse2Supported = #True

        ;save registers
        !push rsi
        !push rdi

        ;calculate the pointers
        !mov rdi,[p.p_ImageData+16]
        !mov rsi,rdi
        !mov rax,[p.v_Width+16]
        !mul qword[p.v_PixelSize+16]
        !mov rdx,rax
        !add rdi,rdx

        ;calculate the counters
        !mov rax,[p.v_Height+16]
        !dec rax
        !mul qword[p.v_Width+16]
        !mul qword[p.v_PixelSize+16]
        !mov rcx,rax
        !shr rcx,7
        !and rax,127
        !mov r10,rax

        ;process a part of the data to cut the length to a multiple of 128
        !test r10,r10
        !je Tsi_UnFilterUp_Sse2CutLengthEnd
        
        !align 8
        !Tsi_UnFilterUp_Sse2CutLengthStart:
      
          !mov al,[rdi]
          !add al,[rsi]
          !mov [rdi],al
          
          !inc rsi
          !inc rdi
      
        !dec r10
        !jne Tsi_UnFilterUp_Sse2CutLengthStart

        !align 8
        !Tsi_UnFilterUp_Sse2CutLengthEnd:
        
        ;process the rest of the data
        !test rcx,rcx
        !je Tsi_UnFilterUp_Sse2LoopEnd
        
        !align 8
        !Tsi_UnFilterUp_Sse2LoopStart:

          !movdqu xmm0,[rsi]
          !movdqu xmm1,[rsi+16]
          !movdqu xmm2,[rsi+32]
          !movdqu xmm3,[rsi+48]
          !movdqu xmm4,[rsi+64]
          !movdqu xmm5,[rsi+80]
          !movdqu xmm6,[rsi+96]
          !movdqu xmm7,[rsi+112]
          
          !paddb xmm0,[rdi]
          !paddb xmm1,[rdi+16]
          !paddb xmm2,[rdi+32]
          !paddb xmm3,[rdi+48]
          !paddb xmm4,[rdi+64]
          !paddb xmm5,[rdi+80]
          !paddb xmm6,[rdi+96]
          !paddb xmm7,[rdi+112]

          !movdqu [rdi],xmm0
          !movdqu [rdi+16],xmm1
          !movdqu [rdi+32],xmm2
          !movdqu [rdi+48],xmm3
          !movdqu [rdi+64],xmm4
          !movdqu [rdi+80],xmm5
          !movdqu [rdi+96],xmm6
          !movdqu [rdi+112],xmm7

          !add rsi,128
          !add rdi,128
        
        !dec rcx
        !jne Tsi_UnFilterUp_Sse2LoopStart
        
        !align 8
        !Tsi_UnFilterUp_Sse2LoopEnd:

        ;restore the registers
        !pop rdi
        !pop rsi

        ;end SSE2 state
        !emms

      ElseIf Tsi_MmxSupported = #True

        ;save registers
        !push rsi
        !push rdi

        ;calculate the pointers
        !mov rdi,[p.p_ImageData+16]
        !mov rsi,rdi
        !mov rax,[p.v_Width+16]
        !mul qword[p.v_PixelSize+16]
        !mov rdx,rax
        !add rdi,rdx

        ;calculate the counters
        !mov rax,[p.v_Height+16]
        !dec rax
        !mul qword[p.v_Width+16]
        !mul qword[p.v_PixelSize+16]
        !mov rcx,rax
        !shr rcx,6
        !and rax,63
        !mov r10,rax

        ;process a part of the data to cut the length to a multiple of 64
        !test r10,r10
        !je Tsi_UnFilterUp_MmxCutLengthEnd
        
        !align 8
        !Tsi_UnFilterUp_MmxCutLengthStart:
      
          !mov al,[rdi]
          !add al,[rsi]
          !mov [rdi],al
          
          !inc rsi
          !inc rdi
      
        !dec r10
        !jne Tsi_UnFilterUp_MmxCutLengthStart

        !align 8
        !Tsi_UnFilterUp_MmxCutLengthEnd:

        ;process the rest of the data
        !test rcx,rcx
        !je Tsi_UnFilterUp_MmxLoopEnd

        !align 8
        !Tsi_UnFilterUp_MmxLoopStart:

          !movq mm0,[rsi]
          !movq mm1,[rsi+8]
          !movq mm2,[rsi+16]
          !movq mm3,[rsi+24]
          !movq mm4,[rsi+32]
          !movq mm5,[rsi+40]
          !movq mm6,[rsi+48]
          !movq mm7,[rsi+56]

          !paddb mm0,[rdi]
          !paddb mm1,[rdi+8]
          !paddb mm2,[rdi+16]
          !paddb mm3,[rdi+24]
          !paddb mm4,[rdi+32]
          !paddb mm5,[rdi+40]
          !paddb mm6,[rdi+48]
          !paddb mm7,[rdi+56]

          !movq [rdi],mm0
          !movq [rdi+8],mm1
          !movq [rdi+16],mm2
          !movq [rdi+24],mm3
          !movq [rdi+32],mm4
          !movq [rdi+40],mm5
          !movq [rdi+48],mm6
          !movq [rdi+56],mm7
          
          !add rsi,64
          !add rdi,64

        !dec rcx
        !jne Tsi_UnFilterUp_MmxLoopStart

        !align 8
        !Tsi_UnFilterUp_MmxLoopEnd:

        ;restore the registers
        !pop rdi
        !pop rsi

        ;end MMX state
        !emms

      Else
      
        !push rsi
        !push rdi

        !mov rax,[p.v_Height+16]
        !dec rax
        !mul qword[p.v_Width+16]
        !mul qword[p.v_PixelSize+16]        
        !mov rcx,rax
        
        !mov rdi,[p.p_ImageData+16]
        !mov rsi,rdi
        !mov rax,[p.v_Width+16]
        !mul qword[p.v_PixelSize+16]
        !mov rdx,rax        
        !add rdi,rdx
        
        !align 8
        !Tsi_UnFilterUp_LoopStart:
        
          !mov al,[rdi]
          !add al,[rsi]
          !mov [rdi],al
          
          !inc rsi
          !inc rdi
          
        !dec rcx
        !jne Tsi_UnFilterUp_LoopStart
      
        !pop rdi
        !pop rsi
      
      EndIf

    CompilerDefault
    
      Protected.i X, ByteSize
      Protected *ActualChannel.Tsi_Pixel_Channel
      Protected *PriorChannel.Tsi_Pixel_Channel
      
      *PriorChannel  = *ImageData
      *ActualChannel = *ImageData + Width * PixelSize
      
      Height - 1
      ByteSize = Width * Height * PixelSize
      
      For X = 1 To ByteSize
        
        *ActualChannel\Channel = *ActualChannel\Channel + *PriorChannel\Channel
        *ActualChannel + 1
        *PriorChannel + 1
    
      Next

  CompilerEndSelect

EndProcedure

;Undos the average filter.
Procedure Tsi_UnFilterAverage(*ImageData, Width.i, Height.i, PixelSize.i)

  CompilerSelect #PB_Compiler_Processor
  
    CompilerCase #PB_Processor_x86

      !push ebx
      !push esi
      !push edi
      !push ebp

      !mov eax,[p.v_Width+16]
      !mul dword[p.v_PixelSize+16]
      
      !mov edi,[p.p_ImageData+16]
      !mov esi,edi
      !mov ebp,edi
      !add edi,eax
      !add edi,dword[p.v_PixelSize+16]
      !add esi,dword[p.v_PixelSize+16]
      !add ebp,eax
      
      !mov eax,[p.v_Width+16]
      !dec eax
      !mul dword[p.v_PixelSize+16]
      !mov ebx,eax
      
      !mov edx,[p.v_Height+16]
      !dec edx
      !push edx
      
      !align 4
      !Tsi_UnFilterAverage_Y_LoopStart:
      
        !mov ecx,ebx
        
        !align 4
        !Tsi_UnFilterAverage_X_LoopStart:

          !xor eax,eax
          !mov al,[esi]
          !xor edx,edx
          !mov dl,[ebp]
          !add eax,edx
          !shr eax,1
          !add al,[edi]
          !mov [edi],al
          !inc edi
          !inc esi
          !inc ebp

        !dec ecx
        !jne Tsi_UnFilterAverage_X_LoopStart
        
        !add edi,dword[p.v_PixelSize+20]
        !add esi,dword[p.v_PixelSize+20]
        !add ebp,dword[p.v_PixelSize+20]
        !pop edx
        
      !dec edx
      !push edx
      !jne Tsi_UnFilterAverage_Y_LoopStart
      
      !pop ebp
      !pop edi
      !pop esi
      !pop ebx

    CompilerCase #PB_Processor_x64

      !push rbx
      !push rsi
      !push rdi
      !push r12
      
      !mov r12,qword[p.v_PixelSize+32]
      
      !mov rax,[p.v_Width+32]
      !mul r12
      
      !mov r8,[p.p_ImageData+32]
      !mov r9,r8
      !mov r10,r8
      !add r8,rax
      !add r8,4
      !add r9,4
      !add r10,rax

      !mov rax,[p.v_Width+32]
      !dec rax
      !mul r12
      !mov rbx,rax
      
      !mov rdx,[p.v_Height+32]
      !dec rdx
      
      !align 8
      !Tsi_UnFilterAverage_Y_LoopStart:
      
        !mov rcx,rbx
        
        !align 8
        !Tsi_UnFilterAverage_X_LoopStart:

          !xor rax,rax
          !mov al,[r9]
          !xor r11,r11
          !mov r11l,[r10]
          !add rax,r11
          !shr rax,1
          !add al,[r8]
          !mov [r8],al
          !inc r8
          !inc r9
          !inc r10

        !dec rcx
        !jne Tsi_UnFilterAverage_X_LoopStart
        
        !add r8,r12
        !add r9,r12
        !add r10,r12
        
      !dec rdx
      !jne Tsi_UnFilterAverage_Y_LoopStart

      !pop r12
      !pop rdi
      !pop rsi
      !pop rbx

    CompilerDefault

      Protected.i X, Y, LineSize
      Protected *ActualChannel.Tsi_Pixel_Channel
      Protected *PriorChannelUp.Tsi_Pixel_Channel
      Protected *PriorChannelSub.Tsi_Pixel_Channel
    
      LineSize = Width * PixelSize
      
      *PriorChannelUp  = *ImageData + PixelSize
      *PriorChannelSub = *ImageData + LineSize
      *ActualChannel   = *ImageData + LineSize + PixelSize
    
      Width - 1
      Width = Width * PixelSize
      Height - 1
      
      For Y = 1 To Height
      
        For X = 1 To Width
        
          *ActualChannel\Channel = *ActualChannel\Channel + (*PriorChannelUp\Channel + *PriorChannelSub\Channel) / 2
          *ActualChannel + 1
          *PriorChannelUp + 1
          *PriorChannelSub + 1
          
        Next
        
        *PriorChannelSub + PixelSize
        *PriorChannelUp + PixelSize
        *ActualChannel + PixelSize
        
      Next

  CompilerEndSelect
 
EndProcedure

;Decodes a TSI located in memory.
;Returns a pointer to the raw image data.
;Returns all basic infos in *TsiHeader as a TSI header.
;Returns palette infos in *Palettes as Tsi_Palettes structure.
;Returns 0 if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_DecodeTsi(*Tsi, *TsiHeader.Tsi_Header, *Palettes.Tsi_Palettes)

  Protected.i UncompressedSize, PaletteEntrySize, PixelCnt, ImageDataSize
  Protected.f PixelSize
  Protected.q Signature
  Protected *DecompBuffer
  Protected *ImageDataStart
  
  ;copy the TSI header for returning it,
  ;so the original don't gets altered by byte order conversion

  CopyMemory(*Tsi, *TsiHeader, SizeOf(Tsi_Header))
  
  ;check for format signature
  
  CompilerIf #PB_Compiler_Processor = #PB_Processor_PowerPC
    Signature = #Tsi_Signature_Big
  CompilerElse
    Signature = #Tsi_Signature_Little
  CompilerEndIf
  
  If *TsiHeader\Signature <> Signature
    Tsi_LastError = #Tsi_Error_WrongSignature
    Debug "Tsi_DecodeTsi: Signature is not matching TSI signature, file isn't a TSI."
    ProcedureReturn 0
  EndIf
  
  ;check for format version
  If *TsiHeader\FormatVersion <> #Tsi_FormatVersion
    Tsi_LastError = #Tsi_Error_NotSupportedVersion
    Debug "Tsi_DecodeTsi: Not supported format version: " + Str(*TsiHeader\FormatVersion)
    ProcedureReturn 0
  EndIf
  
  ;check for byte order and convert header if needed
  If *TsiHeader\Flags & #Tsi_Flag_BigEndianHeader = #Tsi_Flag_BigEndianHeader
    
    CompilerIf #PB_Compiler_Processor = #PB_Processor_x86 Or #PB_Compiler_Processor = #PB_Processor_x64

      Tsi_ConvertByteOrderWord(@*TsiHeader\Width)
      Tsi_ConvertByteOrderWord(@*TsiHeader\Height)
      Tsi_ConvertByteOrderDWord(@*TsiHeader\CompressedSize)
      
    CompilerEndIf
    
  Else
    
    CompilerIf #PB_Compiler_Processor = #PB_Processor_PowerPC
      
      Tsi_ConvertByteOrderWord(@*TsiHeader\Width)
      Tsi_ConvertByteOrderWord(@*TsiHeader\Height)
      Tsi_ConvertByteOrderDWord(@*TsiHeader\CompressedSize)
      
    CompilerEndIf

  EndIf

  ;calculate count of pixel
  PixelCnt = *TsiHeader\Width * *TsiHeader\Height

  ;get pixel size
  PixelSize = Tsi_GetPixelSize(*TsiHeader\PixelFormat)
  
  ;get palette entry size
  PaletteEntrySize = Tsi_GetPaletteEntrySize(*TsiHeader\PixelFormat)
  
  ;calculate image data size
  ImageDataSize = Round(*TsiHeader\Width * PixelSize, #PB_Round_Up) * *TsiHeader\Height
  
  ;calculate uncompressed size
  UncompressedSize = ImageDataSize + (PaletteEntrySize * *TsiHeader\ColorCount * *TsiHeader\PaletteCount)

  ;check for compression and decompress
  *ImageDataStart = AllocateMemory(UncompressedSize)
  If *ImageDataStart = 0
    Tsi_LastError = #Tsi_Error_AllocMem
    Debug "Tsi_DecodeTsi: Error on allocating memory."
    ProcedureReturn 0
  EndIf

  Select *TsiHeader\Compression
  
    Case #Tsi_Compression_None

      CopyMemory(*Tsi + SizeOf(Tsi_Header), *ImageDataStart, UncompressedSize)
    
    Case #Tsi_Compression_Zlib
      
      If uncompress(*ImageDataStart, @UncompressedSize, *Tsi + SizeOf(Tsi_Header), *TsiHeader\CompressedSize)
        FreeMemory(*ImageDataStart)
        Tsi_LastError = #Tsi_Error_DecompressZlib
        Debug "Tsi_DecodeTsi: Error on decompressing ZLib compressed TSI."
        ProcedureReturn 0 
      EndIf
    
    Case #Tsi_Compression_Lzma
      
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86 Or #PB_Compiler_Processor = #PB_Processor_x64

        Protected.i SourceSize
        Protected *Props
        
        SourceSize = *TsiHeader\CompressedSize - SizeOf(T_LZMA_HEADER)
        *Props = AllocateMemory(#LZMA_PROPS_SIZE)
        If *Props = 0
          Tsi_LastError = #Tsi_Error_AllocMem
          Debug "Tsi_DecodeTsi: Error on allocating memory."
          ProcedureReturn 0
        EndIf
        
        CopyMemory(*Tsi + SizeOf(Tsi_Header), *Props, #LZMA_PROPS_SIZE)
        
        If LzmaUncompress(*ImageDataStart, @UncompressedSize, *Tsi + SizeOf(Tsi_Header) + SizeOf(T_LZMA_HEADER), @SourceSize, *Props, #LZMA_PROPS_SIZE)  
          FreeMemory(*Props)
          FreeMemory(*ImageDataStart)
          Tsi_LastError = #Tsi_Error_DecompressLzma
          Debug "Tsi_DecodeTsi: Error on decompressing LZMA compressed TSI."
          ProcedureReturn 0 
        EndIf
  
        FreeMemory(*Props)
        
      CompilerElse
        
        FreeMemory(*ImageDataStart)
        Tsi_LastError = #Tsi_Error_NotSupportedLzma
        Debug "Tsi_DecodeTsi: TSI is LZMA compressed and the decoder does not support LZMA compression for the current platform."
        ProcedureReturn 0
      
      CompilerEndIf
 
    Case #Tsi_Compression_Thor
    
      FreeMemory(*ImageDataStart)
      Tsi_LastError = #Tsi_Error_NotSupportedThor
      Debug "Tsi_DecodeTsi: TSI is Thorium compressed and the decoder does not support Thorium compression."
      ProcedureReturn 0

  EndSelect
  
  ;check for transformation and untransform
  Select *TsiHeader\Transformation
  
    Case #Tsi_Transformation_AlphaSort
      Select *TsiHeader\PixelFormat
        Case #Tsi_Format_32bit
          Tsi_UnSortAlpha32(*ImageDataStart, PixelCnt)
        Case #Tsi_Format_64bit
          Tsi_UnSortAlpha64(*ImageDataStart, PixelCnt)
      EndSelect
    
    Case #Tsi_Transformation_ChannelsSort
      Select *TsiHeader\PixelFormat
        Case #Tsi_Format_24bit
          Tsi_UnSortChannels24(*ImageDataStart, PixelCnt)
        Case #Tsi_Format_32bit
          Tsi_UnSortChannels32(*ImageDataStart, PixelCnt) 
        Case #Tsi_Format_48bit
          Tsi_UnSortChannels48(*ImageDataStart, PixelCnt)
        Case #Tsi_Format_64bit
          Tsi_UnSortChannels64(*ImageDataStart, PixelCnt)
      EndSelect
  
  EndSelect

  ;check for filter and unfilter
  Select *TsiHeader\Filter
  
    Case #Tsi_Filter_Sub
      Tsi_UnFilterSub(*ImageDataStart, *TsiHeader\Width, *TsiHeader\Height, PixelSize)
    
    Case #Tsi_Filter_Up
      Tsi_UnFilterUp(*ImageDataStart, *TsiHeader\Width, *TsiHeader\Height, PixelSize)
    
    Case #Tsi_Filter_Average
      Tsi_UnFilterAverage(*ImageDataStart, *TsiHeader\Width, *TsiHeader\Height, PixelSize)
  
  EndSelect

  ;return Palette infos
  If *Palettes <> 0
    *Palettes\EntrySize     = PaletteEntrySize
    *Palettes\ColorCount    = *TsiHeader\ColorCount
    *Palettes\PaletteCount  = *TsiHeader\PaletteCount
    *Palettes\PaletteBuffer = *ImageDataStart + ImageDataSize
  EndIf
  
  ProcedureReturn *ImageDataStart

EndProcedure

CompilerEndIf

;---------------------------------------------------------
;TSI Decoder, PB Image
;
;Do not change anything from here!

CompilerIf #Tsi_Compile_PbImageDecoder = #True

;Similar to PB's CatchImage. Decodes a TSI in memory to a PB image.
;Returns a PB image number.
;Returns -1 if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_CatchTsi2Image(PbImageNumber.i, *Tsi, *TsiHeader.Tsi_Header, *Palettes.Tsi_Palettes)
  
  Protected.i Image, Depth, PixelFormat, PaletteBufferSize
  Protected *ImageBuffer
  Protected *RawImageData
  Protected *NewPaletteBuffer
  Protected SrcImageFormat.Tsi_ImageFormat
  Protected DstImageFormat.Tsi_ImageFormat
  
  ;decode the TSI
  
  *RawImageData = Tsi_DecodeTsi(*Tsi, *TsiHeader, *Palettes)
  If *RawImageData = 0
    ProcedureReturn -1
  EndIf
  
  ;check TSI image format to set the correct image depth for the PB image
  
  Select *TsiHeader\PixelFormat
    
    Case #Tsi_Format_16Bit_4444, #Tsi_Format_16Bit_5551, #Tsi_Format_32bit, #Tsi_Format_64bit, #Tsi_Format_Index1Bit32Pal, #Tsi_Format_Index1Bit24PalAlpha, #Tsi_Format_Index2Bit32Pal, #Tsi_Format_Index2Bit24PalAlpha, #Tsi_Format_Index4Bit32Pal, #Tsi_Format_Index4Bit24PalAlpha, #Tsi_Format_Index8Bit32Pal, #Tsi_Format_Index8Bit24PalAlpha
      Depth = 32
      
    Default
      Depth = 24
      
  EndSelect
  
  ;create the PB image
  
  Image = CreateImage(PbImageNumber, *TsiHeader\Width, *TsiHeader\Height, Depth)
  If Image = 0
    FreeMemory(*RawImageData)
    Tsi_LastError = #Tsi_Error_PbCreateImage
    Debug "Tsi_CatchTsi2Image: Error on creating PB image."
    ProcedureReturn -1
  EndIf
  
  If PbImageNumber <> #PB_Any
    Image = PbImageNumber
  EndIf
  
  ;get access to the pixel buffer of the PB image
  
  If StartDrawing(ImageOutput(Image)) = 0
    FreeImage(Image)
    FreeMemory(*RawImageData)
    Tsi_LastError = #Tsi_Error_PbImageAccess
    Debug "Tsi_CatchTsi2Image: Can't access PB image."
    ProcedureReturn -1
  EndIf
  
  *ImageBuffer = DrawingBuffer()
  If *ImageBuffer = 0
    StopDrawing()
    FreeImage(Image)
    FreeMemory(*RawImageData)
    Tsi_LastError = #Tsi_Error_PbImageBufferAccess
    Debug "Tsi_CatchTsi2Image: Can't access PB image buffer."
    ProcedureReturn -1
  EndIf
  
  ;get and set the parameters for the image format converter
  
  SrcImageFormat\PixelFormat = *TsiHeader\PixelFormat
  
  If *TsiHeader\Flags & #Tsi_Flag_YReversed = #Tsi_Flag_YReversed
    SrcImageFormat\YReversed = #True
  Else
    SrcImageFormat\YReversed = #False
  EndIf
  
  If *TsiHeader\Flags & (#Tsi_Flag_AlphaIsFirst | #Tsi_Flag_PixelFormatRgb) = #Tsi_Flag_AlphaIsFirst | #Tsi_Flag_PixelFormatRgb
    SrcImageFormat\ChannelOrder = #Tsi_ChannelOrder_ARGB
  ElseIf *TsiHeader\Flags & #Tsi_Flag_PixelFormatRgb = #Tsi_Flag_PixelFormatRgb
    SrcImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
  ElseIf *TsiHeader\Flags & #Tsi_Flag_AlphaIsFirst = #Tsi_Flag_AlphaIsFirst
    SrcImageFormat\ChannelOrder = #Tsi_ChannelOrder_ABGR
  Else
    SrcImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
  EndIf
  
  If *TsiHeader\Flags & #Tsi_Flag_BigEndianImage = #Tsi_Flag_BigEndianImage
    SrcImageFormat\ByteOrder = #Tsi_ByteOrder_BigEndian
  Else
    SrcImageFormat\ByteOrder = #Tsi_ByteOrder_LittleEndian
  EndIf
  
  DstImageFormat\Pitch = DrawingBufferPitch()
  SrcImageFormat\Pitch = *TsiHeader\Width * Round(Tsi_GetPixelSize(*TsiHeader\PixelFormat), #PB_Round_Up)
  
  PixelFormat = DrawingBufferPixelFormat()
  
  Select PixelFormat
      
    Case #PB_PixelFormat_24Bits_RGB
      DstImageFormat\PixelFormat  = #Tsi_Format_24bit
      DstImageFormat\YReversed    = #False
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      DstImageFormat\ByteOrder    = #LittleEndian
      
    Case #PB_PixelFormat_24Bits_RGB | #PB_PixelFormat_ReversedY
      DstImageFormat\PixelFormat  = #Tsi_Format_24bit
      DstImageFormat\YReversed    = #True
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      DstImageFormat\ByteOrder    = #LittleEndian
      
    Case #PB_PixelFormat_24Bits_BGR
      DstImageFormat\PixelFormat  = #Tsi_Format_24bit
      DstImageFormat\YReversed    = #False
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      DstImageFormat\ByteOrder    = #LittleEndian
      
    Case #PB_PixelFormat_24Bits_BGR | #PB_PixelFormat_ReversedY
      DstImageFormat\PixelFormat  = #Tsi_Format_24bit
      DstImageFormat\YReversed    = #True
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      DstImageFormat\ByteOrder    = #LittleEndian
      
    Case #PB_PixelFormat_32Bits_RGB
      DstImageFormat\PixelFormat  = #Tsi_Format_32bit
      DstImageFormat\YReversed    = #False
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      DstImageFormat\ByteOrder    = #BigEndian
      
    Case #PB_PixelFormat_32Bits_RGB | #PB_PixelFormat_ReversedY
      DstImageFormat\PixelFormat  = #Tsi_Format_32bit
      DstImageFormat\YReversed    = #True
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      DstImageFormat\ByteOrder    = #BigEndian
      
    Case #PB_PixelFormat_32Bits_BGR
      DstImageFormat\PixelFormat  = #Tsi_Format_32bit
      DstImageFormat\YReversed    = #False
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      DstImageFormat\ByteOrder    = #BigEndian
      
    Case #PB_PixelFormat_32Bits_BGR | #PB_PixelFormat_ReversedY
      DstImageFormat\PixelFormat  = #Tsi_Format_32bit
      DstImageFormat\YReversed    = #True
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      DstImageFormat\ByteOrder    = #BigEndian
      
  EndSelect

  ;convert and write the raw image to the PB image
  
  Tsi_ConvertImageData(*TsiHeader\Width, *TsiHeader\Height, *RawImageData, SrcImageFormat, *ImageBuffer, DstImageFormat, 0, 0)
  
  ;clean up
  
  StopDrawing()
  
  ;copy Palette buffer, so it don't gets freed if the raw image data gets freed
  
  If *Palettes <> 0 And *TsiHeader\PaletteCount > 0
    
    PaletteBufferSize = *Palettes\PaletteCount * *Palettes\ColorCount * *Palettes\EntrySize
    *NewPaletteBuffer = AllocateMemory(PaletteBufferSize)
    CopyMemory(*Palettes\PaletteBuffer, *NewPaletteBuffer, PaletteBufferSize)
    *Palettes\PaletteBuffer = *NewPaletteBuffer
    
  ElseIf *TsiHeader\PaletteCount > 0
    
    *Palettes\PaletteBuffer = 0
    
  EndIf
  
  ;clean up
  
  FreeMemory(*RawImageData)
  
  ProcedureReturn Image

EndProcedure

;Similar to PB's LoadImage. Loads a TSI from a file and decodes it into a PB image.
;Returns a PB image number.
;Returns 0 if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_LoadTsi2Image(PbImageNumber.i, FileName.s, *TsiHeader.Tsi_Header, *Palettes.Tsi_Palettes)

  Protected.i FileLength, Image
  Protected *TsiBuffer

  *TsiBuffer = Tsi_LoadTsiFile(FileName, @FileLength)
  If *TsiBuffer = 0
    ProcedureReturn 0
  EndIf
  
  Image = Tsi_CatchTsi2Image(PbImageNumber.i, *TsiBuffer, *TsiHeader, *Palettes.Tsi_Palettes)
  
  FreeMemory(*TsiBuffer)
  
  ProcedureReturn Image

EndProcedure

;replacement for PB's CatchImage
Procedure.i Tsi_CatchImage(Image.i, *Memory.Quad, Size = -1)
  
  Protected.i Result
  Protected TsiHeader.Tsi_Header
  Protected Palettes.Tsi_Palettes
  
  If *Memory = 0
    ProcedureReturn #False
  EndIf
  
  CompilerIf #PB_Compiler_Processor = #PB_Processor_PowerPC
  If *Memory\q = #Tsi_Signature_Big
  CompilerElse
  If *Memory\q = #Tsi_Signature_Little
  CompilerEndIf
    Result = Tsi_CatchTsi2Image(Image, *Memory, TsiHeader, Palettes)
    If Result = -1
      ProcedureReturn #False
    Else
      If Image = #PB_Any
        ProcedureReturn Result
      Else
        ProcedureReturn #True
      EndIf
    EndIf
  Else
    If Size = -1
      ProcedureReturn CatchImage(Image, *Memory)
    Else
      ProcedureReturn CatchImage(Image, *Memory, Size)
    EndIf
  EndIf
  
EndProcedure

;replacement for PB's LoadImage
Procedure.i Tsi_LoadImage(Image.i, FileName.s, Flags = -1)
  
  Protected.i Result
  Protected TsiHeader.Tsi_Header
  Protected Palettes.Tsi_Palettes
  
  If LCase(GetExtensionPart(FileName)) = "tsi"
    Result = Tsi_LoadTsi2Image(Image, FileName, TsiHeader, Palettes)
    If Result = -1
      ProcedureReturn #False
    Else
      If Image = #PB_Any
        ProcedureReturn Result
      Else
        ProcedureReturn #True
      EndIf
    EndIf
  Else
    If Flags = -1
      ProcedureReturn LoadImage(Image, FileName)
    Else
      ProcedureReturn LoadImage(Image, FileName, Flags)
    EndIf
  EndIf
  
EndProcedure

CompilerEndIf

;---------------------------------------------------------
;TSI Decoder, PB Sprite
;
;Do not change anything from here!

CompilerIf #Tsi_Compile_PbSpriteDecoder = #True

;Similar to PB's CatchSprite. Decodes a TSI in memory to a PB sprite.
;Mode is the same as on PB's CatchSprite.  
;Returns a PB sprite number.
;Returns -1 if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_CatchTsi2Sprite(PbSpriteNumber.i, *Tsi, *TsiHeader.Tsi_Header, *Palettes.Tsi_Palettes, Mode.i = 0)

  Protected.i Sprite, PixelFormat, PaletteBufferSize
  Protected *ImageBuffer
  Protected *RawImageData
  Protected *NewPaletteBuffer
  Protected SrcImageFormat.Tsi_ImageFormat
  Protected DstImageFormat.Tsi_ImageFormat
  
  ;decode the TSI
  
  *RawImageData = Tsi_DecodeTsi(*Tsi, *TsiHeader, *Palettes)
  If *RawImageData = 0
    ProcedureReturn -1
  EndIf

  ;create the PB sprite
  
  Sprite = CreateSprite(PbSpriteNumber, *TsiHeader\Width, *TsiHeader\Height, Mode)
  If Sprite = 0
    FreeMemory(*RawImageData)
    Tsi_LastError = #Tsi_Error_PbCreateSprite
    Debug "Tsi_CatchTsi2Sprite: Error on creating PB sprite."
    ProcedureReturn -1
  EndIf
  
  If PbSpriteNumber <> #PB_Any
    Sprite = PbSpriteNumber
  EndIf
  
  ;get access to the pixel buffer of the PB sprite
  
  If StartDrawing(SpriteOutput(Sprite)) = 0
    FreeSprite(Sprite)
    FreeMemory(*RawImageData)
    Tsi_LastError = #Tsi_Error_PbSpriteAccess
    Debug "Tsi_CatchTsi2Sprite: Can't access PB Sprite."
    ProcedureReturn -1
  EndIf
  
  *ImageBuffer = DrawingBuffer()
  If *ImageBuffer = 0
    StopDrawing()
    FreeSprite(Sprite)
    FreeMemory(*RawImageData)
    Tsi_LastError = #Tsi_Error_PbSpriteBufferAccess
    Debug "Tsi_CatchTsi2Image: Can't access PB Sprite buffer."
    ProcedureReturn -1
  EndIf

  ;get and set the parameters for the image format converter
  
  SrcImageFormat\PixelFormat = *TsiHeader\PixelFormat
  
  If *TsiHeader\Flags & #Tsi_Flag_YReversed = #Tsi_Flag_YReversed
    SrcImageFormat\YReversed = #True
  Else
    SrcImageFormat\YReversed = #False
  EndIf
  
  If *TsiHeader\Flags & (#Tsi_Flag_AlphaIsFirst | #Tsi_Flag_PixelFormatRgb) = #Tsi_Flag_AlphaIsFirst | #Tsi_Flag_PixelFormatRgb
    SrcImageFormat\ChannelOrder = #Tsi_ChannelOrder_ARGB
  ElseIf *TsiHeader\Flags & #Tsi_Flag_PixelFormatRgb = #Tsi_Flag_PixelFormatRgb
    SrcImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
  ElseIf *TsiHeader\Flags & #Tsi_Flag_AlphaIsFirst = #Tsi_Flag_AlphaIsFirst
    SrcImageFormat\ChannelOrder = #Tsi_ChannelOrder_ABGR
  Else
    SrcImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
  EndIf
  
  If *TsiHeader\Flags & #Tsi_Flag_BigEndianImage = #Tsi_Flag_BigEndianImage
    SrcImageFormat\ByteOrder = #Tsi_ByteOrder_BigEndian
  Else
    SrcImageFormat\ByteOrder = #Tsi_ByteOrder_LittleEndian
  EndIf
  
  DstImageFormat\Pitch = DrawingBufferPitch()
  SrcImageFormat\Pitch = *TsiHeader\Width * Round(Tsi_GetPixelSize(*TsiHeader\PixelFormat), #PB_Round_Up)
  
  PixelFormat = DrawingBufferPixelFormat()
  
  Select PixelFormat
      
    Case #PB_PixelFormat_8Bits
      If Mode & #PB_Sprite_Alpha = #PB_Sprite_Alpha
        DstImageFormat\PixelFormat = #Tsi_Format_Grayscale8Bit
      Else
        DstImageFormat\PixelFormat = #Tsi_Format_Index8Bit24Pal
      EndIf
      DstImageFormat\YReversed    = #False
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      DstImageFormat\ByteOrder    = #LittleEndian
      
    Case #PB_PixelFormat_8Bits | #PB_PixelFormat_ReversedY
      If Mode & #PB_Sprite_Alpha = #PB_Sprite_Alpha
        DstImageFormat\PixelFormat = #Tsi_Format_Grayscale8Bit
      Else
        DstImageFormat\PixelFormat = #Tsi_Format_Index8Bit24Pal
      EndIf
      DstImageFormat\YReversed    = #True
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      DstImageFormat\ByteOrder    = #LittleEndian
      
    Case #PB_PixelFormat_15Bits
      DstImageFormat\PixelFormat  = #Tsi_Format_16Bit_5551
      DstImageFormat\YReversed    = #False
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_ARGB
      DstImageFormat\ByteOrder    = #LittleEndian
      
    Case #PB_PixelFormat_15Bits | #PB_PixelFormat_ReversedY
      DstImageFormat\PixelFormat  = #Tsi_Format_16Bit_5551
      DstImageFormat\YReversed    = #True
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_ARGB
      DstImageFormat\ByteOrder    = #LittleEndian
      
    Case #PB_PixelFormat_16Bits
      DstImageFormat\PixelFormat  = #Tsi_Format_16Bit_565
      DstImageFormat\YReversed    = #False
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      DstImageFormat\ByteOrder    = #LittleEndian
      
    Case #PB_PixelFormat_16Bits | #PB_PixelFormat_ReversedY
      DstImageFormat\PixelFormat  = #Tsi_Format_16Bit_565
      DstImageFormat\YReversed    = #True
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      DstImageFormat\ByteOrder    = #LittleEndian

    Case #PB_PixelFormat_24Bits_RGB
      DstImageFormat\PixelFormat  = #Tsi_Format_24bit
      DstImageFormat\YReversed    = #False
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      DstImageFormat\ByteOrder    = #LittleEndian
      
    Case #PB_PixelFormat_24Bits_RGB | #PB_PixelFormat_ReversedY
      DstImageFormat\PixelFormat  = #Tsi_Format_24bit
      DstImageFormat\YReversed    = #True
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      DstImageFormat\ByteOrder    = #LittleEndian
      
    Case #PB_PixelFormat_24Bits_BGR
      DstImageFormat\PixelFormat  = #Tsi_Format_24bit
      DstImageFormat\YReversed    = #False
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      DstImageFormat\ByteOrder    = #LittleEndian
      
    Case #PB_PixelFormat_24Bits_BGR | #PB_PixelFormat_ReversedY
      DstImageFormat\PixelFormat  = #Tsi_Format_24bit
      DstImageFormat\YReversed    = #True
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      DstImageFormat\ByteOrder    = #LittleEndian
      
    Case #PB_PixelFormat_32Bits_RGB
      DstImageFormat\PixelFormat  = #Tsi_Format_32bit
      DstImageFormat\YReversed    = #False
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      DstImageFormat\ByteOrder    = #BigEndian
      
    Case #PB_PixelFormat_32Bits_RGB | #PB_PixelFormat_ReversedY
      DstImageFormat\PixelFormat  = #Tsi_Format_32bit
      DstImageFormat\YReversed    = #True
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      DstImageFormat\ByteOrder    = #BigEndian
      
    Case #PB_PixelFormat_32Bits_BGR
      DstImageFormat\PixelFormat  = #Tsi_Format_32bit
      DstImageFormat\YReversed    = #False
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      DstImageFormat\ByteOrder    = #BigEndian
      
    Case #PB_PixelFormat_32Bits_BGR | #PB_PixelFormat_ReversedY
      DstImageFormat\PixelFormat  = #Tsi_Format_32bit
      DstImageFormat\YReversed    = #True
      DstImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      DstImageFormat\ByteOrder    = #BigEndian
      
  EndSelect

  ;convert and write the raw image to the PB sprite
  
  Tsi_ConvertImageData(*TsiHeader\Width, *TsiHeader\Height, *RawImageData, SrcImageFormat, *ImageBuffer, DstImageFormat, 0, 0)
  
  ;clean up
  
  StopDrawing()
  
  ;copy Palette buffer, so it don't gets freed if the raw image data gets freed
  
  If *Palettes <> 0 And *TsiHeader\PaletteCount > 0
    
    PaletteBufferSize = *Palettes\PaletteCount * *Palettes\ColorCount * *Palettes\EntrySize
    *NewPaletteBuffer = AllocateMemory(PaletteBufferSize)
    CopyMemory(*Palettes\PaletteBuffer, *NewPaletteBuffer, PaletteBufferSize)
    *Palettes\PaletteBuffer = *NewPaletteBuffer
    
  ElseIf *TsiHeader\PaletteCount > 0
    
    *Palettes\PaletteBuffer = 0
    
  EndIf
  
  ;clean up
  
  FreeMemory(*RawImageData)
  
  ProcedureReturn Sprite

EndProcedure

;Similar to PB's LoadSprite. Loads a TSI from a file and decodes it into a PB sprite.
;Returns a PB sprite number.
;Returns 0 if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_LoadTsi2Sprite(PbSpriteNumber.i, FileName.s, *TsiHeader.Tsi_Header, *Palettes.Tsi_Palettes, Mode.i = 0)

  Protected.i FileLength, Sprite
  Protected *TsiBuffer

  *TsiBuffer = Tsi_LoadTsiFile(FileName, @FileLength)
  If *TsiBuffer = 0
    ProcedureReturn 0
  EndIf
  
  Sprite = Tsi_CatchTsi2Sprite(PbSpriteNumber.i, *TsiBuffer, *TsiHeader, *Palettes.Tsi_Palettes, Mode)
  
  FreeMemory(*TsiBuffer)
  
  ProcedureReturn Sprite

EndProcedure

;replacement for PB's CatchSprite
Procedure.i Tsi_CatchSprite(Sprite.i, *Memory.Quad, Mode = 0)
  
  Protected.i Result
  Protected TsiHeader.Tsi_Header
  Protected Palettes.Tsi_Palettes
  
  If *Memory = 0
    ProcedureReturn #False
  EndIf
  
  CompilerIf #PB_Compiler_Processor = #PB_Processor_PowerPC
  If *Memory\q = #Tsi_Signature_Big
  CompilerElse
  If *Memory\q = #Tsi_Signature_Little
  CompilerEndIf
    Result = Tsi_CatchTsi2Sprite(Sprite, *Memory, TsiHeader, Palettes, Mode)
    If Result = -1
      ProcedureReturn #False
    Else
      If Sprite = #PB_Any
        ProcedureReturn Result
      Else
        ProcedureReturn #True
      EndIf
    EndIf
  Else
    ProcedureReturn CatchSprite(Sprite, *Memory, Mode)
  EndIf
  
EndProcedure

;replacement for PB's LoadSprite
Procedure.i Tsi_LoadSprite(Sprite.i, FileName.s, Mode = 0)
  
  Protected.i Result
  Protected TsiHeader.Tsi_Header
  Protected Palettes.Tsi_Palettes
  
  If LCase(GetExtensionPart(FileName)) = "tsi"
    Result = Tsi_LoadTsi2Sprite(Sprite, FileName, TsiHeader, Palettes, Mode)
    If Result = -1
      ProcedureReturn #False
    Else
      If Sprite = #PB_Any
        ProcedureReturn Result
      Else
        ProcedureReturn #True
      EndIf
    EndIf
  Else
    ProcedureReturn LoadSprite(Sprite, FileName, Mode)
  EndIf
  
EndProcedure

CompilerEndIf

;---------------------------------------------------------
;TSI Encoder, Shared Procedures (DONE)
;
;Do not change anything from here!

CompilerIf #Tsi_Compile_PbImageEncoder = #True Or #Tsi_Compile_PbSpriteEncoder = #True

;compresses a memory block with LZMA
Procedure.i PackMemory_LZMA(*SourceBuff, *DestBuff, iSourceSize, *iDestSize, iCompressionLevel = 5, iDictSize = #LZMA_DICT_4M)
 ; *SourceBuff  = ptr to the source buffer
 ; *DestBuff    = ptr to the destination buffer
 ; iSourceSize  = size of the source buffer
 ; *iDestSize   = ptr to the size of the destination buffer (it will contain the packed size on exit)
 
 ; NOTE: the size of the destination buffer *should* be at least the size of the source + SizeOf(T_LZMA_HEADER)
 ; NOTE: iCompressionLevel must be between 0 (lowest) and 9 (highest) - default 5
 ; NOTE: iDictSize must be between 12 (1 << 12 = 4 KB) and 28 (1 << 28 = 256 MB) - default 4MB
 ; NOTE: the destination buffer will contain a T_LZMA_HEADER followed by the packed data
 ; NOTE: #LZMA_ERROR_OUTPUT_EOF means the file cannot be compressed (or the destination buffer is too small)
 
 Protected iResult, iDestSize, iOutPropsSize, *OutProps, qSourceLen.q   
 
 Protected Lc = 3 
 Protected Lp = 0
 Protected Pb = 2
 Protected Fb = 32
 Protected iNumThreads = 2
 
 iDestSize = PeekI(*iDestSize) - SizeOf(T_LZMA_HEADER)
 
 If iCompressionLevel < 0 Or iCompressionLevel > 9
    ProcedureReturn #LZMA_ERROR_PARAM
 EndIf
 
 If iDictSize < 12 Or iDictSize > 28 ; 4 KB to 256 MB
     ProcedureReturn #LZMA_ERROR_PARAM
 EndIf
 iDictSize = 1 << iDictSize ; default 22 = 4 MB
 
 ; Allocate memory for the properties section
 *OutProps = AllocateMemory(#LZMA_PROPS_SIZE) ; 5 bytes
 
 iOutPropsSize = #LZMA_PROPS_SIZE
 
 iResult = LzmaCompress (*DestBuff + SizeOf(T_LZMA_HEADER), @iDestSize, *SourceBuff, iSourceSize, *OutProps, @iOutPropsSize, iCompressionLevel, iDictSize, Lc,Lp,Pb,Fb, iNumThreads) 

 If iResult <> #LZMA_OK Or iDestSize = 0 Or iOutPropsSize = 0
    FreeMemory(*OutProps)
    ProcedureReturn iResult
 EndIf
 
 ; promote to quad
 qSourceLen = iSourceSize
 
 ; write the header for the destination buffer
 CopyMemory(*OutProps, *DestBuff, #LZMA_PROPS_SIZE)
 CopyMemory(@qSourceLen, *DestBuff + #LZMA_PROPS_SIZE, 8)
 
 ; return the size of the compressed buffer starting at *DestBuff
 PokeI(*iDestSize, iDestSize + SizeOf(T_LZMA_HEADER)) 
 
 FreeMemory(*OutProps)
    
 ProcedureReturn iResult
 
EndProcedure  

;Transforms the raw image data of a TSI, for bedder compression.
;Separates the alpha channel and moves it to the front of the image data.
Procedure Tsi_SortAlpha32(*ImageData, Size.i)

  Protected.i i, ByteSize
  Protected *Buffer
  Protected *PixelPos.Tsi_Pixel_BGRA
  Protected *AlphaPos.Tsi_Pixel_Channel
  Protected *ColorPos.Tsi_Pixel_BGR

  ByteSize = Size * 4
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)
  
  *PixelPos = *Buffer
  *AlphaPos = *ImageData
  *ColorPos = *ImageData + Size
  
  For i = 1 To Size
    
    *AlphaPos\Channel = *PixelPos\Alpha
    *AlphaPos + 1

    *ColorPos\Blue  = *PixelPos\Blue
    *ColorPos\Green = *PixelPos\Green
    *ColorPos\Red   = *PixelPos\Red
    *ColorPos + 3
    
    *PixelPos + 4

  Next
  
  FreeMemory(*Buffer)

EndProcedure

;Transforms the raw image data of a TSI, for bedder compression.
;Separates the alpha channel and moves it to the front of the image data.
Procedure Tsi_SortAlpha64(*ImageData, Size.i)
  
  Protected.i i, ByteSize
  Protected *Buffer
  Protected *PixelPos.Tsi_Pixel_BGRA_16
  Protected *AlphaPos.Tsi_Pixel_Channel_16
  Protected *ColorPos.Tsi_Pixel_BGR_16

  ByteSize = Size * 8
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)
  
  *PixelPos = *Buffer
  *AlphaPos = *ImageData
  *ColorPos = *ImageData + (Size * 2)
  
  For i = 1 To Size
    
    *AlphaPos\Channel = *PixelPos\Alpha
    *AlphaPos + 2

    *ColorPos\Blue  = *PixelPos\Blue
    *ColorPos\Green = *PixelPos\Green
    *ColorPos\Red   = *PixelPos\Red
    *ColorPos + 6
    
    *PixelPos + 8

  Next
  
  FreeMemory(*Buffer)

EndProcedure

;Transforms the raw image data of a TSI, for bedder compression.
;Separates all channels.
Procedure Tsi_SortChannels24(*ImageData, Size.i)

  Protected.i i, ByteSize
  Protected *Buffer
  Protected *PixelPos.Tsi_Pixel_BGR
  Protected *BluePos.Tsi_Pixel_Channel
  Protected *GreenPos.Tsi_Pixel_Channel
  Protected *RedPos.Tsi_Pixel_Channel  

  ByteSize = Size * 3
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)
  
  *PixelPos = *Buffer
  
  *BluePos  = *ImageData
  *GreenPos = *BluePos + Size
  *RedPos   = *GreenPos + Size
  
  For i = 1 To Size
    
    *BluePos\Channel  = *PixelPos\Blue
    *BluePos + 1

    *GreenPos\Channel = *PixelPos\Green
    *GreenPos + 1

    *RedPos\Channel   = *PixelPos\Red
    *RedPos + 1
    
    *PixelPos + 3

  Next
  
  FreeMemory(*Buffer)

EndProcedure

;Transforms the raw image data of a TSI, for bedder compression.
;Separates all channels.
Procedure Tsi_SortChannels32(*ImageData, Size.i)

  Protected.i i, ByteSize
  Protected *Buffer
  Protected *PixelPos.Tsi_Pixel_BGRA
  Protected *BluePos.Tsi_Pixel_Channel
  Protected *GreenPos.Tsi_Pixel_Channel
  Protected *RedPos.Tsi_Pixel_Channel  
  Protected *AlphaPos.Tsi_Pixel_Channel

  ByteSize = Size * 4
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)
  
  *PixelPos = *Buffer
  
  *BluePos  = *ImageData
  *GreenPos = *BluePos + Size
  *RedPos   = *GreenPos + Size
  *AlphaPos = *RedPos + Size
  
  For i = 1 To Size
    
    *BluePos\Channel  = *PixelPos\Blue
    *BluePos + 1

    *GreenPos\Channel = *PixelPos\Green
    *GreenPos + 1

    *RedPos\Channel   = *PixelPos\Red
    *RedPos + 1
    
    *AlphaPos\Channel = *PixelPos\Alpha
    *AlphaPos + 1
    
    *PixelPos + 4

  Next
  
  FreeMemory(*Buffer)

EndProcedure

;Transforms the raw image data of a TSI, for bedder compression.
;Separates all channels.
Procedure Tsi_SortChannels48(*ImageData, Size.i)

  Protected.i i, ByteSize
  Protected *Buffer
  Protected *PixelPos.Tsi_Pixel_BGR_16
  Protected *BluePos.Tsi_Pixel_Channel_16
  Protected *GreenPos.Tsi_Pixel_Channel_16
  Protected *RedPos.Tsi_Pixel_Channel_16

  ByteSize = Size * 6
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)
  
  *PixelPos = *Buffer
  
  *BluePos  = *ImageData
  *GreenPos = *BluePos + (Size * 2)
  *RedPos   = *GreenPos + (Size * 2)
  
  For i = 1 To Size
    
    *BluePos\Channel  = *PixelPos\Blue
    *BluePos + 2

    *GreenPos\Channel = *PixelPos\Green
    *GreenPos + 2

    *RedPos\Channel   = *PixelPos\Red
    *RedPos + 2
    
    *PixelPos + 6

  Next
  
  FreeMemory(*Buffer)

EndProcedure

;Transforms the raw image data of a TSI, for bedder compression.
;Separates all channels.
Procedure Tsi_SortChannels64(*ImageData, Size.i)

  Protected.i i, ByteSize
  Protected *Buffer
  Protected *PixelPos.Tsi_Pixel_BGRA_16
  Protected *BluePos.Tsi_Pixel_Channel_16
  Protected *GreenPos.Tsi_Pixel_Channel_16
  Protected *RedPos.Tsi_Pixel_Channel_16
  Protected *AlphaPos.Tsi_Pixel_Channel_16

  ByteSize = Size * 8
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)
  
  *PixelPos = *Buffer
  
  *BluePos  = *ImageData
  *GreenPos = *BluePos + (Size * 2)
  *RedPos   = *GreenPos + (Size * 2)
  *AlphaPos = *RedPos + (Size * 2)
  
  For i = 1 To Size
    
    *BluePos\Channel  = *PixelPos\Blue
    *BluePos + 2

    *GreenPos\Channel = *PixelPos\Green
    *GreenPos + 2

    *RedPos\Channel   = *PixelPos\Red
    *RedPos + 2
    
    *AlphaPos\Channel = *PixelPos\Alpha
    *AlphaPos + 2
    
    *PixelPos + 8

  Next
  
  FreeMemory(*Buffer)

EndProcedure

;Filters the raw image data of a TSI, for bedder compression.
Procedure Tsi_FilterSub(*ImageData, Width.i, Height.i, PixelSize.i)

  Protected.i X, Y, ByteSize
  Protected *Buffer
  Protected *ActualChannel.Tsi_Pixel_Channel
  Protected *PriorChannel.Tsi_Pixel_Channel
  Protected *DestChannel.Tsi_Pixel_Channel

  ByteSize = Width * Height * PixelSize
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)

  *DestChannel   = *ImageData + PixelSize
  *PriorChannel  = *Buffer
  *ActualChannel = *Buffer + PixelSize

  Width = (Width - 1) * PixelSize
  
  For Y = 1 To Height
  
    For X = 1 To Width
    
      *DestChannel\Channel = *ActualChannel\Channel - *PriorChannel\Channel
      *DestChannel + 1
      *ActualChannel + 1
      *PriorChannel + 1
    
    Next
    
    *PriorChannel + PixelSize
    *ActualChannel + PixelSize
    *DestChannel + PixelSize
    
  Next
  
  FreeMemory(*Buffer)
  
EndProcedure

;Filters the raw image data of a TSI, for bedder compression.
Procedure Tsi_FilterUp(*ImageData, Width.i, Height.i, PixelSize.i)

  Protected.i X, LineSize, ByteSize
  Protected *Buffer
  Protected *ActualChannel.Tsi_Pixel_Channel
  Protected *PriorChannel.Tsi_Pixel_Channel
  Protected *DestChannel.Tsi_Pixel_Channel

  ByteSize = Width * Height * PixelSize
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)

  LineSize = Width * PixelSize
  
  *DestChannel   = *ImageData + LineSize
  *PriorChannel  = *Buffer
  *ActualChannel = *Buffer + LineSize
    
  Height - 1
  ByteSize = Width * Height * PixelSize
  
  For X = 1 To ByteSize
    
    *DestChannel\Channel = *ActualChannel\Channel - *PriorChannel\Channel
    *DestChannel + 1
    *ActualChannel + 1
    *PriorChannel + 1

  Next
  
  FreeMemory(*Buffer)

EndProcedure

;Filters the raw image data of a TSI, for bedder compression.
Procedure Tsi_FilterAverage(*ImageData, Width.i, Height.i, PixelSize.i)

  Protected.i X, Y, LineSize, ByteSize
  Protected *Buffer
  Protected *ActualChannel.Tsi_Pixel_Channel
  Protected *PriorChannelUp.Tsi_Pixel_Channel
  Protected *PriorChannelSub.Tsi_Pixel_Channel
  Protected *DestChannel.Tsi_Pixel_Channel

  ByteSize = Width * Height * PixelSize
  *Buffer = AllocateMemory(ByteSize)
  CopyMemory(*ImageData, *Buffer, ByteSize)

  LineSize = Width * PixelSize
  
  *DestChannel     = *ImageData + LineSize + PixelSize
  *PriorChannelUp  = *Buffer + PixelSize
  *PriorChannelSub = *Buffer + LineSize
  *ActualChannel   = *Buffer + LineSize + PixelSize

  Width = (Width - 1) * PixelSize
  Height - 1
  
  For Y = 1 To Height
  
    For X = 1 To Width
    
      *DestChannel\Channel = *ActualChannel\Channel - (*PriorChannelUp\Channel + *PriorChannelSub\Channel) / 2
      *DestChannel + 1
      *ActualChannel + 1
      *PriorChannelUp + 1
      *PriorChannelSub + 1
      
    Next
    
    *PriorChannelSub + PixelSize
    *PriorChannelUp + PixelSize
    *ActualChannel + PixelSize
    *DestChannel + PixelSize
    
  Next

  FreeMemory(*Buffer)

EndProcedure

;Encodes raw image data to a TSI in memory.
;Returns a pointer to the TSI.
;Returns size of the TSI in *TsiSize.
;Returns 0 if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_EncodeTsi(*RawImageData, *InputImageFormat.Tsi_ImageFormat, *OutputImageFormat.Tsi_ImageFormat, OutputByteOrder.i, Width.i, Height.i, *Palettes.Tsi_Palettes, TransparentColor.q, Filter.i, Transformation.i, Compression.i, CompressionLevel.i, *TsiSize.Integer)

  Protected.i PixelCnt, InputPixelSize, OutputPixelSize, InputImageDataSize, OutputImageDataSize, CompBufferSize
  Protected *OutputImageDataStart
  Protected *TsiBuffer
  Protected *CompBuffer
  Protected *Header.Tsi_Header

  ;calculate pixel count
  
  PixelCnt = Width * Height
  
  ;calculate input image data size
  
  InputPixelSize = Tsi_GetPixelSize(*InputImageFormat\PixelFormat)
  InputImageDataSize = PixelCnt * InputPixelSize
  
  ;calculate output image data size
  
  OutputPixelSize = Tsi_GetPixelSize(*OutputImageFormat\PixelFormat)  
  OutputImageDataSize = PixelCnt * OutputPixelSize
  
  ;calculate size of resulting TSI, not regarding compression
  
  *TsiSize\i = OutputImageDataSize + SizeOf(Tsi_Header)
  
  ;allocate memory for the resulting TSI
  
  *TsiBuffer = AllocateMemory(*TsiSize\i)
  If *TsiBuffer = 0
    Tsi_LastError = #Tsi_Error_AllocMem
    Debug "Tsi_EncodeTsi: Error on allocating memory."
    ProcedureReturn 0
  EndIf

  ;create TSI header
  
  *Header = *TsiBuffer
  
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x86 Or #PB_Compiler_Processor = #PB_Processor_x64
    *Header\Signature        = #Tsi_Signature_Little
  CompilerElse
    *Header\Signature        = #Tsi_Signature_Big
  CompilerEndIf
  
  *Header\FormatVersion    = #Tsi_FormatVersion
  *Header\Compression      = Compression
  *Header\Filter           = Filter
  *Header\Transformation   = Transformation
  *Header\PixelFormat      = *OutputImageFormat\PixelFormat
  *Header\ColorCount       = 0
  *Header\PaletteCount     = 0
  *Header\TransparentColor = TransparentColor
  *Header\Width            = Width
  *Header\Height           = Height
  
  Select *OutputImageFormat\ChannelOrder
      
    Case #Tsi_ChannelOrder_BGRA
      *Header\Flags = 0
      
    Case #Tsi_ChannelOrder_ABGR
      *Header\Flags = #Tsi_Flag_AlphaIsFirst
      
    Case #Tsi_ChannelOrder_RGBA
      *Header\Flags = #Tsi_Flag_PixelFormatRgb
      
    Case #Tsi_ChannelOrder_ARGB
      *Header\Flags = #Tsi_Flag_PixelFormatRgb | #Tsi_Flag_AlphaIsFirst
      
  EndSelect
  
  If *OutputImageFormat\YReversed = #True
    *Header\Flags = *Header\Flags | #Tsi_Flag_YReversed
  EndIf
  
  If OutputByteOrder = #Tsi_ByteOrder_BigEndian
    *Header\Flags = *Header\Flags | #Tsi_Flag_BigEndianHeader
  EndIf
  
  If *OutputImageFormat\ByteOrder = #Tsi_ByteOrder_BigEndian
    *Header\Flags = *Header\Flags | #Tsi_Flag_BigEndianImage
  EndIf
  
  ;calculate start address of output image data
  
  *OutputImageDataStart = *TsiBuffer + SizeOf(Tsi_Header)
  
  ;convert input image data to output image data
  
  *OutputImageFormat\Pitch = Width * Round(OutputPixelSize, #PB_Round_Up)
  Tsi_ConvertImageData(Width, Height, *RawImageData, *InputImageFormat, *OutputImageDataStart, *OutputImageFormat, 0, 0)
  
  ;apply image filter

  Select Filter
      
    Case #Tsi_Filter_Sub
      Tsi_FilterSub(*OutputImageDataStart, Width, Height, OutputPixelSize)  
      
    Case #Tsi_Filter_Up
      Tsi_FilterUp(*OutputImageDataStart, Width, Height, OutputPixelSize)
      
    Case #Tsi_Filter_Average
      Tsi_FilterAverage(*OutputImageDataStart, Width, Height, OutputPixelSize)
      
  EndSelect

  ;apply image transformation

  Select Transformation
  
    Case #Tsi_Transformation_AlphaSort
      Select *OutputImageFormat\PixelFormat
        Case #Tsi_Format_32bit
          Tsi_SortAlpha32(*OutputImageDataStart, PixelCnt)
        Case #Tsi_Format_64bit
          Tsi_SortAlpha64(*OutputImageDataStart, PixelCnt)
      EndSelect
    
    Case #Tsi_Transformation_ChannelsSort
      Select *OutputImageFormat\PixelFormat
        Case #Tsi_Format_24bit
          Tsi_SortChannels24(*OutputImageDataStart, PixelCnt)
        Case #Tsi_Format_32bit
          Tsi_SortChannels32(*OutputImageDataStart, PixelCnt) 
        Case #Tsi_Format_48bit
          Tsi_SortChannels48(*OutputImageDataStart, PixelCnt)
        Case #Tsi_Format_64bit
          Tsi_SortChannels64(*OutputImageDataStart, PixelCnt)
      EndSelect
  
  EndSelect
  
  ;apply compression

  Select Compression
  
    Case #Tsi_Compression_Zlib
      CompBufferSize = OutputImageDataSize + 13 + (OutputImageDataSize / 100)

      *CompBuffer = AllocateMemory(CompBufferSize)
      If *CompBuffer = 0
        FreeMemory(*TsiBuffer)
        Tsi_LastError = #Tsi_Error_AllocMem
        Debug "Tsi_EncodeTsi: Error on allocating memory."
        ProcedureReturn 0
      EndIf
      
      If compress2(*CompBuffer, @CompBufferSize, *OutputImageDataStart, OutputImageDataSize, CompressionLevel) 
       
        FreeMemory(*CompBuffer)
        FreeMemory(*TsiBuffer)
        Tsi_LastError = #Tsi_Error_CompressZlib
        Debug "Tsi_EncodeTsi: Error on compressing image data with ZLib."
        ProcedureReturn 0

      Else
        
        OutputImageDataSize = CompBufferSize
        *TsiSize\i = SizeOf(Tsi_Header) + OutputImageDataSize
        
        *TsiBuffer = ReAllocateMemory(*TsiBuffer, *TsiSize\i)
        If *TsiBuffer = 0
          FreeMemory(*CompBuffer)
          FreeMemory(*TsiBuffer)
          Tsi_LastError = #Tsi_Error_AllocMem
          Debug "Tsi_EncodeTsi: Error on allocating memory."
          ProcedureReturn 0
        EndIf
        
        CopyMemory(*CompBuffer, *OutputImageDataStart, OutputImageDataSize)
        FreeMemory(*CompBuffer)
      
      EndIf
      
    Case #Tsi_Compression_Lzma
      
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86 Or #PB_Compiler_Processor = #PB_Processor_x64

        CompBufferSize = OutputImageDataSize + SizeOf(T_LZMA_HEADER)
        *CompBuffer = AllocateMemory(CompBufferSize)
        If *CompBuffer = 0
          FreeMemory(*TsiBuffer)
          Tsi_LastError = #Tsi_Error_AllocMem
          Debug "Tsi_EncodeTsi: Error on allocating memory."
          ProcedureReturn 0
        EndIf
        
        If PackMemory_LZMA(*OutputImageDataStart, *CompBuffer, OutputImageDataSize, @CompBufferSize, CompressionLevel, #LZMA_DICT_4M) <> #LZMA_OK
          
          FreeMemory(*CompBuffer)
          FreeMemory(*TsiBuffer)
          Tsi_LastError = #Tsi_Error_CompressLzma
          Debug "Tsi_EncodeTsi: Error on compressing image data with LZMA."
          ProcedureReturn 0
          
        Else
          
          OutputImageDataSize = CompBufferSize
          *TsiSize\i = SizeOf(Tsi_Header) + OutputImageDataSize
          
          *TsiBuffer = ReAllocateMemory(*TsiBuffer, *TsiSize\i)
          If *TsiBuffer = 0
            FreeMemory(*CompBuffer)
            FreeMemory(*TsiBuffer)
            Tsi_LastError = #Tsi_Error_AllocMem
            Debug "Tsi_EncodeTsi: Error on allocating memory."
            ProcedureReturn 0
          EndIf
          
          CopyMemory(*CompBuffer, *OutputImageDataStart, OutputImageDataSize)
          FreeMemory(*CompBuffer) 
          
        EndIf
          
      CompilerElse
          
          FreeMemory(*TsiBuffer)
          Tsi_LastError = #Tsi_Error_NotSupportedLzma
          Debug "Tsi_EncodeTsi: LZMA compression chosen for image data compression is not supported for this platform."
          ProcedureReturn 0
          
      CompilerEndIf
          
    Case #Tsi_Compression_Thor
      FreeMemory(*TsiBuffer)
      Tsi_LastError = #Tsi_Error_NotSupportedThor
      Debug "Tsi_EncodeTsi: Thorium compression chosen for image data compression is not supported for this platform."
      ProcedureReturn 0

  EndSelect
  
  *Header\CompressedSize = OutputImageDataSize

  ;convert header byte order if needed
  
  CompilerIf #PB_Compiler_Processor = #PB_Processor_PowerPC
    If OutputByteOrder = #Tsi_ByteOrder_LittleEndian
      Tsi_ConvertByteOrderWord(@*Header\Width)
      Tsi_ConvertByteOrderWord(@*Header\Height)
      Tsi_ConvertByteOrderDWord(@*Header\CompressedSize)
    EndIf    
  CompilerElse
    If OutputByteOrder = #Tsi_ByteOrder_BigEndian
      Tsi_ConvertByteOrderWord(@*Header\Width)
      Tsi_ConvertByteOrderWord(@*Header\Height)
      Tsi_ConvertByteOrderDWord(@*Header\CompressedSize)
    EndIf
  CompilerEndIf
  
  ProcedureReturn *TsiBuffer

EndProcedure

CompilerEndIf

;---------------------------------------------------------
;TSI Encoder, PB Image (IN PROGRESS)
;
;Do not change anything from here!

CompilerIf #Tsi_Compile_PbImageEncoder = #True

;Similar to PB's SaveImage. But saves the TSI to memory and not to hard disk.
;Returns a pointer to the TSI.
;Returns size of the TSI in *TsiSize.
;Returns 0 if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_Save2MemoryFromImage(Image.i, *OutputImageFormat.Tsi_ImageFormat, OutputByteOrder.i, Filter.i, Transformation.i, Compression.i, CompressionLevel.i, *TsiSize.Integer)

  Protected.i SrcPitch, PixelFormat, SrcImageFormat, SrcYReversed, SrcChannelOrder
  Protected *RawImageBuffer
  Protected *Tsi
  Protected InputImageFormat.Tsi_ImageFormat

  If StartDrawing(ImageOutput(Image)) = 0
    Tsi_LastError = #Tsi_Error_PbImageAccess
    Debug "Tsi_Save2MemoryFromImage: Can't access PB image."
    ProcedureReturn 0
  EndIf
  
  *RawImageBuffer = DrawingBuffer()
  If *RawImageBuffer = 0
    StopDrawing()
    Tsi_LastError = #Tsi_Error_PbImageBufferAccess
    Debug "Tsi_Save2MemoryFromImage: Can't access PB image buffer."
    ProcedureReturn 0
  EndIf

  InputImageFormat\Pitch = DrawingBufferPitch()
  PixelFormat = DrawingBufferPixelFormat()
  
  Select PixelFormat
      
    Case #PB_PixelFormat_24Bits_RGB
      InputImageFormat\PixelFormat  = #Tsi_Format_24bit
      InputImageFormat\YReversed    = #False
      InputImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      
    Case #PB_PixelFormat_24Bits_RGB | #PB_PixelFormat_ReversedY
      InputImageFormat\PixelFormat  = #Tsi_Format_24bit
      InputImageFormat\YReversed    = #True
      InputImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      
    Case #PB_PixelFormat_24Bits_BGR
      InputImageFormat\PixelFormat  = #Tsi_Format_24bit
      InputImageFormat\YReversed    = #False
      InputImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      
    Case #PB_PixelFormat_24Bits_BGR | #PB_PixelFormat_ReversedY
      InputImageFormat\PixelFormat  = #Tsi_Format_24bit
      InputImageFormat\YReversed    = #True
      InputImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      
    Case #PB_PixelFormat_32Bits_RGB
      InputImageFormat\PixelFormat  = #Tsi_Format_32bit
      InputImageFormat\YReversed    = #False
      InputImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      
    Case #PB_PixelFormat_32Bits_RGB | #PB_PixelFormat_ReversedY
      InputImageFormat\PixelFormat  = #Tsi_Format_32bit
      InputImageFormat\YReversed    = #True
      InputImageFormat\ChannelOrder = #Tsi_ChannelOrder_RGBA
      
    Case #PB_PixelFormat_32Bits_BGR
      InputImageFormat\PixelFormat  = #Tsi_Format_32bit
      InputImageFormat\YReversed    = #False
      InputImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      
    Case #PB_PixelFormat_32Bits_BGR | #PB_PixelFormat_ReversedY
      InputImageFormat\PixelFormat  = #Tsi_Format_32bit
      InputImageFormat\YReversed    = #True
      InputImageFormat\ChannelOrder = #Tsi_ChannelOrder_BGRA
      
  EndSelect
  
  If *OutputImageFormat\PixelFormat = #Tsi_Format_AsInput
    *OutputImageFormat\PixelFormat = InputImageFormat\PixelFormat
  EndIf
  If *OutputImageFormat\YReversed = #Tsi_YReversed_AsInput
    *OutputImageFormat\YReversed = InputImageFormat\YReversed
  EndIf
  If *OutputImageFormat\ChannelOrder = #Tsi_ChannelOrder_AsInput
    *OutputImageFormat\ChannelOrder = InputImageFormat\ChannelOrder
  EndIf
  If OutputByteOrder = #Tsi_ByteOrder_AsInput
    CompilerIf #PB_Compiler_Processor = #PB_Processor_x86 Or #PB_Compiler_Processor = #PB_Processor_x64
      OutputByteOrder = #Tsi_ByteOrder_LittleEndian
    CompilerElse
      OutputByteOrder = #Tsi_ByteOrder_BigEndian
    CompilerEndIf
  EndIf

  *Tsi = Tsi_EncodeTsi(*RawImageBuffer, InputImageFormat, *OutputImageFormat, OutputByteOrder, ImageWidth(Image), ImageHeight(Image), 0, Filter, Transformation, Compression, CompressionLevel, *TsiSize)
  
  StopDrawing()
  
  ProcedureReturn *Tsi

EndProcedure

;Similar to PB's SaveImage. But saves the TSI to memory and not to hard disk.
;The difference to Tsi_Save2MemoryFromImage is that is will choose the best
;filter and transformation automaticly by testing which is the best for the given
;image. Therefor it's much slower but outputs allways the best optimized TSI.
;Returns a pointer to the TSI.
;Returns size of the TSI in *TsiSize.
;Returns 0 if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_BestSave2MemoryFromImage(Image.i, *TsiSize.Integer)

  
  
  
  
  

EndProcedure

;Similar to PB's SaveImage.
;Returns #True if it succeeds.
;Returns #False if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_SaveFromImage(Image.i, FileName.s, *OutputImageFormat.Tsi_ImageFormat, OutputByteOrder.i, Filter.i, Transformation.i, Compression.i, CompressionLevel.i)
  
  Protected.i File, TsiSize
  Protected *Tsi
  
  *Tsi = Tsi_Save2MemoryFromImage(Image, *OutputImageFormat, OutputByteOrder, Filter, Transformation, Compression, CompressionLevel, @TsiSize)
  If *Tsi = 0
    ProcedureReturn #False
  EndIf
  
  File = CreateFile(#PB_Any, FileName)
  If File = 0
    FreeMemory(*Tsi)
    Tsi_LastError = #Tsi_Error_CreateFile   
    Debug "Tsi_SaveFromImage: Can't create file: " + FileName
    ProcedureReturn #False
  EndIf
  
  WriteData(File, *Tsi, TsiSize)
  CloseFile(File)
  FreeMemory(*Tsi)
  
  ProcedureReturn #True

EndProcedure

;Similar to PB's SaveImage.
;The difference to Tsi_SaveFromImage is that is will choose the best
;filter and transformation automaticly by testing which is the best for the given
;image. Therefor it's much slower but outputs allways the best optimized TSI.
;Returns #True if it succeeds.
;Returns #False if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_BestSaveFromImage(Image.i, FileName.s)


EndProcedure

CompilerEndIf

;---------------------------------------------------------
;TSI Encoder, PB Sprite (NOT STARTED)
;
;Do not change anything from here!

CompilerIf #Tsi_Compile_PbSpriteEncoder = #True

;Encodes a sprite to raw image data suitable for encoding to a TSI.
;Returns a pointer to the raw image data.
;Returns size of the raw image data in *RawImageDataSize.
;Returns 0 if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_EncodeSprite2RawImageData(Sprite.i, *RawImageDataSize.Integer)

  Protected.i X, Y, Width, Height, DestLineLen, RawImageSize, Pitch, PixelFormat, SrcY
  Protected *SpriteBuffer
  Protected *RawImageBuffer
  Protected *SrcPixel.Long
  Protected *DestPixel.Long

  If SpriteDepth(Sprite) <> 32
    Tsi_LastError = #Tsi_Error_PbSpriteWrongPixelFormat
    Debug "Tsi_EncodeSprite2RawImageData: Wrong pixel format of PB sprite, depth is not 32bit."  
    ProcedureReturn 0
  EndIf

  Width = SpriteWidth(Sprite)
  Height = SpriteHeight(Sprite)
  *RawImageDataSize\i = Width * Height * 4

  *RawImageBuffer = AllocateMemory(*RawImageDataSize\i)
  If *RawImageBuffer = 0
    Tsi_LastError = #Tsi_Error_AllocMem
    Debug "Tsi_EncodeSprite2RawImageData: Error on allocating memory."
    ProcedureReturn 0
  EndIf

  If StartDrawing(SpriteOutput(Sprite)) = 0
    FreeMemory(*RawImageBuffer)
    Tsi_LastError = #Tsi_Error_PbSpriteAccess
    Debug "Tsi_EncodeSprite2RawImageData: Can't access PB sprite."
    ProcedureReturn 0
  EndIf

  *SpriteBuffer = DrawingBuffer()
  If *SpriteBuffer = 0
    StopDrawing()
    FreeMemory(*RawImageBuffer)
    Tsi_LastError = #Tsi_Error_PbSpriteBufferAccess
    Debug "Tsi_EncodeSprite2RawImageData: Can't access PB sprite buffer."
    ProcedureReturn 0
  EndIf

  Pitch = DrawingBufferPitch()
  PixelFormat = DrawingBufferPixelFormat()

  DestLineLen = Width * 4

  Select PixelFormat

    Case #PB_PixelFormat_32Bits_BGR
    
      If Pitch = DestLineLen
        CopyMemory(*SpriteBuffer, *RawImageBuffer, *RawImageDataSize\i)
      Else
        For Y = 0 To Height - 1
          CopyMemory(*SpriteBuffer + (Pitch * Y), *RawImageBuffer + (DestLineLen * Y), DestLineLen)
        Next
      EndIf

    Case #PB_PixelFormat_32Bits_RGB
      
      *DestPixel = *RawImageBuffer
      For Y = 0 To Height - 1
        *SrcPixel = *SpriteBuffer + (Pitch * Y)
        For X = 0 To Width - 1
          *DestPixel\l = Tsi_BGRA2RGBA(*SrcPixel\l)
          *SrcPixel + 4
          *DestPixel + 4
        Next
      Next

    Case #Tsi_PB_PixelFormat_32Bits_BGR_ReversedY

      SrcY = Height - 1
      For Y = 0 To Height - 1
        CopyMemory(*SpriteBuffer + (Pitch * SrcY), *RawImageBuffer + (DestLineLen * Y), DestLineLen)
        SrcY - 1
      Next

    Case #Tsi_PB_PixelFormat_32Bits_RGB_ReversedY

      *DestPixel = *RawImageBuffer
      SrcY = Height - 1
      For Y = 0 To Height - 1
        *SrcPixel = *SpriteBuffer + (Pitch * SrcY)
        For X = 0 To Width - 1
          *DestPixel\l = Tsi_BGRA2RGBA(*SrcPixel\l)
          *SrcPixel + 4
          *DestPixel + 4
        Next
        SrcY - 1
      Next

    Default

      StopDrawing()
      FreeMemory(*RawImageBuffer)
      Tsi_LastError = #Tsi_Error_PbSpriteWrongPixelFormat
      Debug "Tsi_EncodeSprite2RawImageData: Wrong pixel format of PB sprite."
      ProcedureReturn 0

  EndSelect

  StopDrawing()

  ProcedureReturn *RawImageBuffer

EndProcedure

;Similar to PB's SaveSprite. But saves the TSI to memory and not to hard disk.
;Returns a pointer to the TSI.
;Returns size of the TSI in *TsiSize.
;Returns 0 if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_Save2MemoryFromSprite(Sprite.i, *TsiSize.Integer, Filter.i, Transformation.i, Compression.i, CompressionLevel.i)

  Protected.i RawImageSize
  Protected *RawImageBuffer
  Protected *Tsi

  *RawImageBuffer = Tsi_EncodeSprite2RawImageData(Sprite, @RawImageSize)
  If *RawImageBuffer = 0
    ProcedureReturn 0
  EndIf

  ;*Tsi = Tsi_EncodeTsi(*RawImageBuffer, *TsiSize, SpriteWidth(Sprite), SpriteHeight(Sprite), Filter, Transformation, Compression, CompressionLevel)
  FreeMemory(*RawImageBuffer)
  
  ProcedureReturn *Tsi

EndProcedure

;Similar to PB's SaveSprite. But saves the TSI to memory and not to hard disk.
;The difference to Tsi_Save2MemoryFromSprite is that is will choose the best
;filter and transformation automaticly by testing which is the best for the given
;sprite. Therefor it's much slower but outputs allways the best optimized TSI.
;Returns a pointer to the TSI.
;Returns size of the TSI in *TsiSize.
;Returns 0 if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_BestSave2MemoryFromSprite(Sprite.i, *TsiSize.Integer)

  Protected.i Width, Height, RawImageSize, BestTsiSize, NewTsiSize, BestTransformation, BestFilter
  Protected *RawImageData
  Protected *BestTsi
  Protected *NewTsi
  
  Width  = SpriteWidth(Sprite)
  Height = SpriteHeight(Sprite)
  
  *RawImageData = Tsi_EncodeSprite2RawImageData(Sprite, @RawImageSize)
  If *RawImageData = 0
    ProcedureReturn 0
  EndIf
  
  ;*BestTsi = Tsi_EncodeTsi(*RawImageData, @BestTsiSize, Width, Height, #Tsi_Filter_None, #Tsi_Transformation_None, #Tsi_Compression_Zlib, 9)
  If *BestTsi = 0
    FreeMemory(*RawImageData)
    ProcedureReturn 0
  EndIf
  
  ;*NewTsi = Tsi_EncodeTsi(*RawImageData, @NewTsiSize, Width, Height, #Tsi_Filter_None, #Tsi_Transformation_AlphaSort, #Tsi_Compression_Zlib, 9)
  If *NewTsi = 0
    FreeMemory(*RawImageData)
    FreeMemory(*BestTsi)
    ProcedureReturn 0
  EndIf
  If NewTsiSize < BestTsiSize
    BestTransformation = #Tsi_Transformation_AlphaSort
    FreeMemory(*BestTsi)
    *BestTsi = *NewTsi
    BestTsiSize = NewTsiSize
  Else
    BestTransformation = #Tsi_Transformation_None
    FreeMemory(*NewTsi)
  EndIf
  
  BestFilter = #Tsi_Filter_None
  
  ;*NewTsi = Tsi_EncodeTsi(*RawImageData, @NewTsiSize, Width, Height, #Tsi_Filter_Sub, BestTransformation, #Tsi_Compression_Zlib, 9)
  If *NewTsi = 0
    FreeMemory(*RawImageData)
    FreeMemory(*BestTsi)
    ProcedureReturn 0
  EndIf
  If NewTsiSize < BestTsiSize
    BestFilter = #Tsi_Filter_Sub
    FreeMemory(*BestTsi)
    *BestTsi = *NewTsi
    BestTsiSize = NewTsiSize
  Else
    FreeMemory(*NewTsi)
  EndIf
  
  ;*NewTsi = Tsi_EncodeTsi(*RawImageData, @NewTsiSize, Width, Height, #Tsi_Filter_Up, BestTransformation, #Tsi_Compression_Zlib, 9)
  If *NewTsi = 0
    FreeMemory(*RawImageData)
    FreeMemory(*BestTsi)
    ProcedureReturn 0
  EndIf
  If NewTsiSize < BestTsiSize
    BestFilter = #Tsi_Filter_Up
    FreeMemory(*BestTsi)
    *BestTsi = *NewTsi
    BestTsiSize = NewTsiSize
  Else
    FreeMemory(*NewTsi)
  EndIf
  
  ;*NewTsi = Tsi_EncodeTsi(*RawImageData, @NewTsiSize, Width, Height, #Tsi_Filter_Average, BestTransformation, #Tsi_Compression_Zlib, 9)
  If *NewTsi = 0
    FreeMemory(*RawImageData)
    FreeMemory(*BestTsi)
    ProcedureReturn 0
  EndIf
  If NewTsiSize < BestTsiSize
    BestFilter = #Tsi_Filter_Average
    FreeMemory(*BestTsi)
    *BestTsi = *NewTsi
    BestTsiSize = NewTsiSize
  Else
    FreeMemory(*NewTsi)
  EndIf

  FreeMemory(*RawImageData)
  *TsiSize\i = BestTsiSize
  
  ProcedureReturn *BestTsi

EndProcedure

;Similar to PB's SaveSprite.
;Returns #True if it succeeds.
;Returns #False if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_SaveFromSprite(Sprite.i, FileName.s, Filter.i, Transformation.i, Compression.i, CompressionLevel.i)

  Protected.i File, TsiSize
  Protected *Tsi
  
  *Tsi = Tsi_Save2MemoryFromSprite(Sprite, @TsiSize, Filter, Transformation, Compression, CompressionLevel)
  If *Tsi = 0
    ProcedureReturn #False
  EndIf
  
  File = CreateFile(#PB_Any, FileName)
  If File = 0
    FreeMemory(*Tsi)
    Tsi_LastError = #Tsi_Error_CreateFile   
    Debug "Tsi_SaveFromSprite: Can't create file: " + FileName
    ProcedureReturn #False
  EndIf
  
  WriteData(File, *Tsi, TsiSize)
  CloseFile(File)
  FreeMemory(*Tsi)
  
  ProcedureReturn #True
  
EndProcedure

;Similar to PB's SaveSprite.
;The difference to Tsi_SaveFromSprite is that is will choose the best
;filter and transformation automaticly by testing which is the best for the given
;image. Therefor it's much slower but outputs allways the best optimized TSI.
;Returns #True if it succeeds.
;Returns #False if it fails, check Tsi_LastError for error code.
Procedure.i Tsi_BestSaveFromSprite(Sprite.i, FileName.s)

  Protected.i File, TsiSize
  Protected *Tsi
  
  *Tsi = Tsi_BestSave2MemoryFromSprite(Sprite, @TsiSize)
  If *Tsi = 0
    ProcedureReturn #False
  EndIf
  
  File = CreateFile(#PB_Any, FileName)
  If File = 0
    FreeMemory(*Tsi)
    Tsi_LastError = #Tsi_Error_CreateFile   
    Debug "Tsi_BestSaveFromSprite: Can't create file: " + FileName
    ProcedureReturn #False
  EndIf
  
  WriteData(File, *Tsi, TsiSize)
  CloseFile(File)
  FreeMemory(*Tsi)
  
  ProcedureReturn #True

EndProcedure

CompilerEndIf

; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 3116
; FirstLine = 381
; Folding = AAAAAAAAA+
; EnableXP